
CREATE SCHEMA documentdb_api;
CREATE SCHEMA documentdb_api_internal;
CREATE SCHEMA documentdb_api_catalog;
CREATE SCHEMA documentdb_data;
CREATE OR REPLACE FUNCTION documentdb_api_catalog.query_match_support(internal)
 RETURNS internal
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $$query_match_support$$;
CREATE OR REPLACE FUNCTION documentdb_api_catalog.bson_query_match(documentdb_core.bson, documentdb_core.bson)
 RETURNS bool
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
 SUPPORT documentdb_api_catalog.query_match_support
AS 'MODULE_PATHNAME', $function$bson_query_match$function$;
CREATE OR REPLACE FUNCTION documentdb_api_catalog.bson_true_match(documentdb_core.bson)
 RETURNS bool
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$bson_true_match$function$;
CREATE OR REPLACE FUNCTION documentdb_api_catalog.dollar_support(internal)
 RETURNS internal
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $$dollar_support$$;
CREATE OR REPLACE FUNCTION documentdb_api_catalog.bson_dollar_eq(documentdb_core.bson, documentdb_core.bson)
 RETURNS bool
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
 SUPPORT documentdb_api_catalog.dollar_support
AS 'MODULE_PATHNAME', $function$bson_dollar_eq$function$;
CREATE OR REPLACE FUNCTION documentdb_api_catalog.bson_dollar_lt(documentdb_core.bson, documentdb_core.bson)
 RETURNS bool
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
 SUPPORT documentdb_api_catalog.dollar_support
AS 'MODULE_PATHNAME', $function$bson_dollar_lt$function$;
CREATE OR REPLACE FUNCTION documentdb_api_catalog.bson_dollar_lte(documentdb_core.bson, documentdb_core.bson)
 RETURNS bool
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
 SUPPORT documentdb_api_catalog.dollar_support
AS 'MODULE_PATHNAME', $function$bson_dollar_lte$function$;
CREATE OR REPLACE FUNCTION documentdb_api_catalog.bson_dollar_gt(documentdb_core.bson, documentdb_core.bson)
 RETURNS bool
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
 SUPPORT documentdb_api_catalog.dollar_support
AS 'MODULE_PATHNAME', $function$bson_dollar_gt$function$;
CREATE OR REPLACE FUNCTION documentdb_api_catalog.bson_dollar_gte(documentdb_core.bson, documentdb_core.bson)
 RETURNS bool
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
 SUPPORT documentdb_api_catalog.dollar_support
AS 'MODULE_PATHNAME', $function$bson_dollar_gte$function$;
CREATE OR REPLACE FUNCTION documentdb_api_catalog.bson_dollar_in(documentdb_core.bson, documentdb_core.bson)
 RETURNS bool
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
 SUPPORT documentdb_api_catalog.dollar_support
AS 'MODULE_PATHNAME', $function$bson_dollar_in$function$;
CREATE OR REPLACE FUNCTION documentdb_api_catalog.bson_dollar_ne(documentdb_core.bson, documentdb_core.bson)
 RETURNS bool
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
 SUPPORT documentdb_api_catalog.dollar_support
AS 'MODULE_PATHNAME', $function$bson_dollar_ne$function$;
CREATE OR REPLACE FUNCTION documentdb_api_catalog.bson_dollar_nin(documentdb_core.bson, documentdb_core.bson)
 RETURNS bool
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
 SUPPORT documentdb_api_catalog.dollar_support
AS 'MODULE_PATHNAME', $function$bson_dollar_nin$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_dollar_range(documentdb_core.bson, documentdb_core.bson)
 RETURNS bool
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
 SUPPORT documentdb_api_catalog.dollar_support
AS 'MODULE_PATHNAME', $function$bson_dollar_range$function$;
CREATE OR REPLACE FUNCTION documentdb_api_catalog.bson_dollar_eq(documentdb_core.bson,documentdb_core.bsonquery)
 RETURNS bool
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
 SUPPORT documentdb_api_catalog.dollar_support
AS 'MODULE_PATHNAME', $function$bson_dollar_eq$function$;
CREATE OR REPLACE FUNCTION documentdb_api_catalog.bson_dollar_lt(documentdb_core.bson,documentdb_core.bsonquery)
 RETURNS bool
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
 SUPPORT documentdb_api_catalog.dollar_support
AS 'MODULE_PATHNAME', $function$bson_dollar_lt$function$;
CREATE OR REPLACE FUNCTION documentdb_api_catalog.bson_dollar_lte(documentdb_core.bson,documentdb_core.bsonquery)
 RETURNS bool
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
 SUPPORT documentdb_api_catalog.dollar_support
AS 'MODULE_PATHNAME', $function$bson_dollar_lte$function$;
CREATE OR REPLACE FUNCTION documentdb_api_catalog.bson_dollar_gt(documentdb_core.bson,documentdb_core.bsonquery)
 RETURNS bool
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
 SUPPORT documentdb_api_catalog.dollar_support
AS 'MODULE_PATHNAME', $function$bson_dollar_gt$function$;
CREATE OR REPLACE FUNCTION documentdb_api_catalog.bson_dollar_gte(documentdb_core.bson,documentdb_core.bsonquery)
 RETURNS bool
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
 SUPPORT documentdb_api_catalog.dollar_support
AS 'MODULE_PATHNAME', $function$bson_dollar_gte$function$;
CREATE OR REPLACE FUNCTION documentdb_api_catalog.bson_dollar_size(documentdb_core.bson, documentdb_core.bson)
 RETURNS bool
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
 SUPPORT documentdb_api_catalog.dollar_support
AS 'MODULE_PATHNAME', $function$bson_dollar_size$function$;
CREATE OR REPLACE FUNCTION documentdb_api_catalog.bson_dollar_elemmatch(documentdb_core.bson, documentdb_core.bson)
 RETURNS bool
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
 SUPPORT documentdb_api_catalog.dollar_support
AS 'MODULE_PATHNAME', $function$bson_dollar_elemmatch$function$;
CREATE OR REPLACE FUNCTION documentdb_api_catalog.bson_dollar_all(documentdb_core.bson, documentdb_core.bson)
 RETURNS bool
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
 SUPPORT documentdb_api_catalog.dollar_support
AS 'MODULE_PATHNAME', $function$bson_dollar_all$function$;
CREATE OR REPLACE FUNCTION documentdb_api_catalog.bson_dollar_exists(documentdb_core.bson, documentdb_core.bson)
 RETURNS bool
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
 SUPPORT documentdb_api_catalog.dollar_support
AS 'MODULE_PATHNAME', $function$bson_dollar_exists$function$;
CREATE OR REPLACE FUNCTION documentdb_api_catalog.bson_dollar_type(documentdb_core.bson, documentdb_core.bson)
 RETURNS bool
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
 SUPPORT documentdb_api_catalog.dollar_support
AS 'MODULE_PATHNAME', $function$bson_dollar_type$function$;
CREATE OR REPLACE FUNCTION documentdb_api_catalog.bson_dollar_bits_all_clear(documentdb_core.bson, documentdb_core.bson)
 RETURNS bool
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
 SUPPORT documentdb_api_catalog.dollar_support
AS 'MODULE_PATHNAME', $function$bson_dollar_bits_all_clear$function$;
CREATE OR REPLACE FUNCTION documentdb_api_catalog.bson_dollar_bits_any_clear(documentdb_core.bson, documentdb_core.bson)
 RETURNS bool
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
 SUPPORT documentdb_api_catalog.dollar_support
AS 'MODULE_PATHNAME', $function$bson_dollar_bits_any_clear$function$;
CREATE OR REPLACE FUNCTION documentdb_api_catalog.bson_dollar_bits_all_set(documentdb_core.bson, documentdb_core.bson)
 RETURNS bool
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
 SUPPORT documentdb_api_catalog.dollar_support
AS 'MODULE_PATHNAME', $function$bson_dollar_bits_all_set$function$;
CREATE OR REPLACE FUNCTION documentdb_api_catalog.bson_dollar_bits_any_set(documentdb_core.bson, documentdb_core.bson)
 RETURNS bool
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
 SUPPORT documentdb_api_catalog.dollar_support
AS 'MODULE_PATHNAME', $function$bson_dollar_bits_any_set$function$;
CREATE OR REPLACE FUNCTION documentdb_api_catalog.bson_dollar_regex(documentdb_core.bson, documentdb_core.bson)
 RETURNS bool
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
 SUPPORT documentdb_api_catalog.dollar_support
AS 'MODULE_PATHNAME', $function$bson_dollar_regex$function$;
CREATE OR REPLACE FUNCTION documentdb_api_catalog.bson_dollar_expr(documentdb_core.bson, documentdb_core.bson)
 RETURNS bool
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$bson_dollar_expr$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_dollar_expr(documentdb_core.bson, documentdb_core.bson, documentdb_core.bson)
 RETURNS bool
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$bson_dollar_expr$function$;
CREATE OR REPLACE FUNCTION documentdb_api_catalog.bson_dollar_json_schema(documentdb_core.bson, documentdb_core.bson)
 RETURNS bool
 LANGUAGE c
 COST 100
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$bson_dollar_json_schema$function$;
CREATE OR REPLACE FUNCTION documentdb_api_catalog.bson_dollar_mod(documentdb_core.bson, documentdb_core.bson)
 RETURNS bool
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
 SUPPORT documentdb_api_catalog.dollar_support
AS 'MODULE_PATHNAME', $function$bson_dollar_mod$function$;
CREATE OR REPLACE FUNCTION documentdb_api_catalog.bson_orderby(documentdb_core.bson, documentdb_core.bson)
 RETURNS documentdb_core.bson
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$command_bson_orderby$function$;
-- ORDER BY operator function for $setWindowFields
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_orderby_partition(documentdb_core.bson, documentdb_core.bson, boolean)
 RETURNS documentdb_core.bson
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$bson_orderby_partition$function$;
-- dummy function that accepts the query planner phase, and exists only to handle the support function handling
-- to push down to the index.
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_dollar_text(documentdb_core.bson, documentdb_core.bson)
 RETURNS bool
 LANGUAGE c
 SUPPORT documentdb_api_catalog.dollar_support
 COST 10000000000 -- really dissuade the planner from using this and force the index.
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$bson_dollar_text$function$;
-- dummy function that exists to support the index operator (below). Needs to be separate from above due to the
-- 'tsquery' being an input. We can't generate the tsquery during the planning phase as we must use the default_language
-- in the index definition as STOP words defaults. Consequently the planner generates the function above, then the support
-- generates the operator below.
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_text_tsquery(documentdb_core.bson, tsquery)
 RETURNS bool
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$bson_dollar_text$function$;
-- This is a function that tracks the input tsquery, and the index options associated with it so that $meta queries
-- can be made to work - injected during the plan phase.
-- Also used to do a runtime $text scan if necessary.
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_text_meta_qual(documentdb_core.bson, tsquery, bytea, bool)
 RETURNS bool
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$bson_dollar_text_meta_qual$function$;
DROP FUNCTION IF EXISTS documentdb_api_internal.bson_query_to_tsquery;
-- This is a diagnostic query used to test translation of $text search clauses to TSQuery in Postgres.
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_query_to_tsquery(query documentdb_core.bson, textSearch text default NULL)
 RETURNS tsquery
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE
AS 'MODULE_PATHNAME', $function$command_bson_query_to_tsquery$function$;
CREATE OR REPLACE FUNCTION documentdb_api_catalog.bson_dollar_project(document documentdb_core.bson, pathSpec documentdb_core.bson)
 RETURNS documentdb_core.bson
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$bson_dollar_project$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_dollar_project(document documentdb_core.bson, pathSpec documentdb_core.bson, variableSpec documentdb_core.bson)
 RETURNS documentdb_core.bson
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$bson_dollar_project$function$;
CREATE OR REPLACE FUNCTION documentdb_api_catalog.bson_dollar_project_find(document documentdb_core.bson, pathSpec documentdb_core.bson, querySpec documentdb_core.bson DEFAULT NULL)
 RETURNS documentdb_core.bson
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE CALLED ON NULL INPUT
AS 'MODULE_PATHNAME', $function$bson_dollar_project_find$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_dollar_project_find(document documentdb_core.bson, pathSpec documentdb_core.bson, querySpec documentdb_core.bson, letVariableSpec documentdb_core.bson)
 RETURNS documentdb_core.bson
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE CALLED ON NULL INPUT
AS 'MODULE_PATHNAME', $function$bson_dollar_project_find$function$;
CREATE OR REPLACE FUNCTION documentdb_api_catalog.bson_dollar_add_fields(document documentdb_core.bson, pathSpec documentdb_core.bson)
 RETURNS documentdb_core.bson
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$bson_dollar_add_fields$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_dollar_add_fields(document documentdb_core.bson, pathSpec documentdb_core.bson, letVariableSpec documentdb_core.bson)
 RETURNS documentdb_core.bson
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$bson_dollar_add_fields$function$;
CREATE OR REPLACE FUNCTION documentdb_api_catalog.bson_dollar_set(document documentdb_core.bson, pathSpec documentdb_core.bson)
 RETURNS documentdb_core.bson
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$bson_dollar_set$function$;
CREATE OR REPLACE FUNCTION documentdb_api_catalog.bson_dollar_unset(document documentdb_core.bson, pathSpec documentdb_core.bson)
 RETURNS documentdb_core.bson
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$bson_dollar_unset$function$;
CREATE OR REPLACE FUNCTION documentdb_api_catalog.bson_dollar_replace_root(document documentdb_core.bson, pathSpec documentdb_core.bson)
 RETURNS documentdb_core.bson
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$bson_dollar_replace_root$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_dollar_replace_root(document documentdb_core.bson, pathSpec documentdb_core.bson, variableSpec documentdb_core.bson)
 RETURNS documentdb_core.bson
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$bson_dollar_replace_root$function$;
CREATE OR REPLACE FUNCTION documentdb_api_catalog.bson_dollar_facet_project(documentdb_core.bson, bool)
 RETURNS documentdb_core.bson
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$bson_dollar_facet_project$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_dollar_merge_documents(document documentdb_core.bson, pathSpec documentdb_core.bson)
 RETURNS documentdb_core.bson
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$bson_dollar_merge_documents$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_dollar_merge_documents_at_path(leftDocument documentdb_core.bson, rightDocument documentdb_core.bson, fieldPath text)
 RETURNS documentdb_core.bson
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$bson_dollar_merge_documents_at_path$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_dollar_lookup_expression_eval_merge(document documentdb_core.bson, pathSpec documentdb_core.bson, variableSpec documentdb_core.bson)
 RETURNS documentdb_core.bson
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$bson_dollar_lookup_expression_eval_merge$function$;
CREATE OR REPLACE FUNCTION documentdb_api_catalog.bson_expression_get(document documentdb_core.bson, expressionSpec documentdb_core.bson, isNullOnEmpty bool default false)
 RETURNS documentdb_core.bson
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$bson_expression_get$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_expression_get(document documentdb_core.bson, expressionSpec documentdb_core.bson, isNullOnEmpty bool, variableSpec documentdb_core.bson)
 RETURNS documentdb_core.bson
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$bson_expression_get$function$;
CREATE OR REPLACE FUNCTION documentdb_api_catalog.bson_expression_map(document documentdb_core.bson, sourceArrayName text, expressionSpec documentdb_core.bson, isNullOnEmpty bool default false)
 RETURNS documentdb_core.bson
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$bson_expression_map$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_expression_map(document documentdb_core.bson, sourceArrayName text, expressionSpec documentdb_core.bson, isNullOnEmpty bool, variableSpec documentdb_core.bson)
 RETURNS documentdb_core.bson
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$bson_expression_map$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_expression_partition_get(document documentdb_core.bson, expressionSpec documentdb_core.bson, isNullOnEmpty bool default false)
 RETURNS documentdb_core.bson
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$bson_expression_partition_get$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_expression_partition_get(document documentdb_core.bson, expressionSpec documentdb_core.bson, isNullOnEmpty bool, variableSpec documentdb_core.bson)
 RETURNS documentdb_core.bson
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$bson_expression_partition_get$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_expression_partition_by_fields_get(document documentdb_core.bson, expressionSpec documentdb_core.bson)
 RETURNS documentdb_core.bson
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$bson_expression_partition_by_fields_get$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_dollar_selectivity(internal, oid, internal, integer)
 RETURNS double precision
 LANGUAGE c
 STABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$bson_dollar_selectivity$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_dollar_not_gt(documentdb_core.bson, documentdb_core.bson)
 RETURNS bool
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
 SUPPORT documentdb_api_catalog.dollar_support
AS 'MODULE_PATHNAME', $function$bson_dollar_not_gt$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_dollar_not_gte(documentdb_core.bson, documentdb_core.bson)
 RETURNS bool
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
 SUPPORT documentdb_api_catalog.dollar_support
AS 'MODULE_PATHNAME', $function$bson_dollar_not_gte$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_dollar_not_lt(documentdb_core.bson, documentdb_core.bson)
 RETURNS bool
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
 SUPPORT documentdb_api_catalog.dollar_support
AS 'MODULE_PATHNAME', $function$bson_dollar_not_lt$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_dollar_not_lte(documentdb_core.bson, documentdb_core.bson)
 RETURNS bool
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
 SUPPORT documentdb_api_catalog.dollar_support
AS 'MODULE_PATHNAME', $function$bson_dollar_not_lte$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_value_dollar_eq(internal, documentdb_core.bson)
 RETURNS internal
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$bson_value_dollar_eq$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_value_dollar_gt(internal, documentdb_core.bson)
 RETURNS internal
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$bson_value_dollar_gt$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_value_dollar_gte(internal, documentdb_core.bson)
 RETURNS internal
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$bson_value_dollar_gte$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_value_dollar_lt(internal, documentdb_core.bson)
 RETURNS internal
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$bson_value_dollar_lt$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_value_dollar_lte(internal, documentdb_core.bson)
 RETURNS internal
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$bson_value_dollar_lte$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_value_dollar_size(internal, documentdb_core.bson)
 RETURNS internal
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$bson_value_dollar_size$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_value_dollar_type(internal, documentdb_core.bson)
 RETURNS internal
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$bson_value_dollar_type$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_value_dollar_in(internal, documentdb_core.bson)
 RETURNS internal
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$bson_value_dollar_in$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_value_dollar_nin(internal, documentdb_core.bson)
 RETURNS internal
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$bson_value_dollar_nin$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_value_dollar_ne(internal, documentdb_core.bson)
 RETURNS internal
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$bson_value_dollar_ne$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_value_dollar_exists(internal, documentdb_core.bson)
 RETURNS internal
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$bson_value_dollar_exists$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_value_dollar_elemmatch(internal, documentdb_core.bson)
 RETURNS internal
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$bson_value_dollar_elemmatch$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_value_dollar_all(internal, documentdb_core.bson)
 RETURNS internal
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$bson_value_dollar_all$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_value_dollar_regex(internal, documentdb_core.bson)
 RETURNS internal
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$bson_value_dollar_regex$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_value_dollar_mod(internal, documentdb_core.bson)
 RETURNS internal
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$bson_value_dollar_mod$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_value_dollar_bits_all_clear(internal, documentdb_core.bson)
 RETURNS internal
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$bson_value_dollar_bits_all_clear$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_value_dollar_bits_any_clear(internal, documentdb_core.bson)
 RETURNS internal
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$bson_value_dollar_bits_any_clear$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_value_dollar_bits_all_set(internal, documentdb_core.bson)
 RETURNS internal
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$bson_value_dollar_bits_all_set$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_value_dollar_bits_any_set(internal, documentdb_core.bson)
 RETURNS internal
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$bson_value_dollar_bits_any_set$function$;
CREATE OPERATOR documentdb_api_catalog.@@ (
    LEFTARG = documentdb_core.bson,
    RIGHTARG = documentdb_core.bson,
    PROCEDURE = documentdb_api_catalog.bson_query_match
);
-- these are runtime operators for specific functions that are compatible
-- with partial filter expressions. For more details see comments on
-- bson_partial_filter_btree_ops.
CREATE OPERATOR documentdb_api_catalog.#= (
    LEFTARG = documentdb_core.bson,
    RIGHTARG = documentdb_core.bson,
    PROCEDURE = documentdb_api_catalog.bson_dollar_eq
);
CREATE OPERATOR documentdb_api_catalog.#> (
    LEFTARG = documentdb_core.bson,
    RIGHTARG = documentdb_core.bson,
    PROCEDURE = documentdb_api_catalog.bson_dollar_gt
);
CREATE OPERATOR documentdb_api_catalog.#>= (
    LEFTARG = documentdb_core.bson,
    RIGHTARG = documentdb_core.bson,
    PROCEDURE = documentdb_api_catalog.bson_dollar_gte
);
CREATE OPERATOR documentdb_api_catalog.#< (
    LEFTARG = documentdb_core.bson,
    RIGHTARG = documentdb_core.bson,
    PROCEDURE = documentdb_api_catalog.bson_dollar_lt
);
CREATE OPERATOR documentdb_api_catalog.#<= (
    LEFTARG = documentdb_core.bson,
    RIGHTARG = documentdb_core.bson,
    PROCEDURE = documentdb_api_catalog.bson_dollar_lte
);
CREATE OPERATOR documentdb_api_catalog.#= (
    LEFTARG = documentdb_core.bson,
    RIGHTARG = documentdb_core.bsonquery,
    PROCEDURE = documentdb_api_catalog.bson_dollar_eq
);
CREATE OPERATOR documentdb_api_catalog.#> (
    LEFTARG = documentdb_core.bson,
    RIGHTARG = documentdb_core.bsonquery,
    PROCEDURE = documentdb_api_catalog.bson_dollar_gt
);
CREATE OPERATOR documentdb_api_catalog.#>= (
    LEFTARG = documentdb_core.bson,
    RIGHTARG = documentdb_core.bsonquery,
    PROCEDURE = documentdb_api_catalog.bson_dollar_gte
);
CREATE OPERATOR documentdb_api_catalog.#< (
    LEFTARG = documentdb_core.bson,
    RIGHTARG = documentdb_core.bsonquery,
    PROCEDURE = documentdb_api_catalog.bson_dollar_lt
);
CREATE OPERATOR documentdb_api_catalog.#<= (
    LEFTARG = documentdb_core.bson,
    RIGHTARG = documentdb_core.bsonquery,
    PROCEDURE = documentdb_api_catalog.bson_dollar_lte
);
CREATE OPERATOR FAMILY documentdb_api_catalog.bsonquery_btree_family USING btree;
CREATE OPERATOR CLASS documentdb_api_catalog.bsonquery_btree_ops
    DEFAULT FOR TYPE documentdb_core.bsonquery USING btree FAMILY documentdb_api_catalog.bsonquery_btree_family AS
        OPERATOR 1 documentdb_core.< (documentdb_core.bsonquery, documentdb_core.bsonquery),
        OPERATOR 2 documentdb_core.<= (documentdb_core.bsonquery, documentdb_core.bsonquery),
        OPERATOR 3 documentdb_core.= (documentdb_core.bsonquery, documentdb_core.bsonquery),
        OPERATOR 4 documentdb_core.>= (documentdb_core.bsonquery, documentdb_core.bsonquery),
        OPERATOR 5 documentdb_core.> (documentdb_core.bsonquery, documentdb_core.bsonquery),
        FUNCTION 1 documentdb_core.bsonquery_compare(documentdb_core.bsonquery, documentdb_core.bsonquery);
CREATE OPERATOR CLASS documentdb_api_catalog.bsonquery_bson_btree_ops
    FOR TYPE documentdb_core.bson USING btree FAMILY documentdb_api_catalog.bsonquery_btree_family AS
        OPERATOR 1 documentdb_api_catalog.#< (documentdb_core.bson, documentdb_core.bsonquery),
        OPERATOR 2 documentdb_api_catalog.#<= (documentdb_core.bson, documentdb_core.bsonquery),
        OPERATOR 3 documentdb_api_catalog.#= (documentdb_core.bson, documentdb_core.bsonquery),
        OPERATOR 4 documentdb_api_catalog.#>= (documentdb_core.bson, documentdb_core.bsonquery),
        OPERATOR 5 documentdb_api_catalog.#> (documentdb_core.bson, documentdb_core.bsonquery),
        FUNCTION 1 documentdb_core.bsonquery_compare(documentdb_core.bson, documentdb_core.bsonquery);
CREATE OPERATOR CLASS documentdb_api_catalog.bson_btree_pfe_ops
    FOR TYPE documentdb_core.bson USING btree FAMILY documentdb_api_catalog.bsonquery_btree_family AS
        OPERATOR 1 documentdb_api_catalog.#< (documentdb_core.bson, documentdb_core.bson),
        OPERATOR 2 documentdb_api_catalog.#<= (documentdb_core.bson, documentdb_core.bson),
        OPERATOR 3 documentdb_api_catalog.#= (documentdb_core.bson, documentdb_core.bson),
        OPERATOR 4 documentdb_api_catalog.#>= (documentdb_core.bson, documentdb_core.bson),
        OPERATOR 5 documentdb_api_catalog.#> (documentdb_core.bson, documentdb_core.bson),
        FUNCTION 1 documentdb_core.bson_compare(documentdb_core.bson, documentdb_core.bson);
CREATE OR REPLACE FUNCTION documentdb_api_catalog.bson_dollar_project_geonear(documentdb_core.bson, documentdb_core.bson)
 RETURNS documentdb_core.bson
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$bson_dollar_project_geonear$function$;
CREATE OR REPLACE FUNCTION documentdb_api_catalog.bson_geonear_distance(documentdb_core.bson, documentdb_core.bson)
 RETURNS float8
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$bson_geonear_distance$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_geonear_within_range(documentdb_core.bson, documentdb_core.bson)
 RETURNS bool
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
 SUPPORT documentdb_api_catalog.dollar_support
AS 'MODULE_PATHNAME', $function$bson_geonear_within_range$function$;
CREATE OR REPLACE FUNCTION documentdb_api_catalog.bson_dollar_geowithin(documentdb_core.bson, documentdb_core.bson)
 RETURNS bool
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
 SUPPORT documentdb_api_catalog.dollar_support
AS 'MODULE_PATHNAME', $function$bson_dollar_geowithin$function$;
CREATE OR REPLACE FUNCTION documentdb_api_catalog.bson_dollar_geointersects(documentdb_core.bson, documentdb_core.bson)
 RETURNS bool
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
 SUPPORT documentdb_api_catalog.dollar_support
AS 'MODULE_PATHNAME', $function$bson_dollar_geointersects$function$;
CREATE OPERATOR documentdb_api_catalog.@|-| (
    LEFTARG = documentdb_core.bson,
    RIGHTARG = documentdb_core.bson,
    PROCEDURE = documentdb_api_catalog.bson_dollar_geowithin,
    RESTRICT = documentdb_core.bson_operator_selectivity
);
CREATE OPERATOR documentdb_api_catalog.@|#| (
    LEFTARG = documentdb_core.bson,
    RIGHTARG = documentdb_core.bson,
    PROCEDURE = documentdb_api_catalog.bson_dollar_geointersects,
    RESTRICT = documentdb_core.bson_operator_selectivity
);
CREATE OPERATOR documentdb_api_catalog.<|-|> (
    LEFTARG = documentdb_core.bson,
    RIGHTARG = documentdb_core.bson,
    PROCEDURE = documentdb_api_catalog.bson_geonear_distance
);
CREATE OPERATOR documentdb_api_internal.@|><| (
    LEFTARG = documentdb_core.bson,
    RIGHTARG = documentdb_core.bson,
    PROCEDURE = documentdb_api_internal.bson_geonear_within_range
);
-- Index options function for bson_gist_geometry_ops_2d operator class family
CREATE OR REPLACE FUNCTION documentdb_api_catalog.bson_gist_geometry_2d_options(internal)
 RETURNS void
 LANGUAGE C
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$bson_gist_geometry_2d_options$function$;
-- GIST compress support function for 2d index, this internally uses Postgis GIST compress support function
-- geometry_gist_compress_2d.
-- It extract the geomtery from a `bson` document and compresses it into the box2df type for storage. It also
-- apply additional mongo db validations on geometries e.g. bound checks.
CREATE OR REPLACE FUNCTION documentdb_api_catalog.bson_gist_geometry_2d_compress(internal)
 RETURNS INTERNAL
 LANGUAGE C
 PARALLEL SAFE
AS 'MODULE_PATHNAME', $function$bson_gist_geometry_2d_compress$function$;
-- GIST distance support functions for bson, used for ORDER BY and nearest neighbour queries
CREATE OR REPLACE FUNCTION documentdb_api_catalog.bson_gist_geometry_distance_2d(internal, documentdb_core.bson, integer)
 RETURNS float8
 LANGUAGE C
 PARALLEL SAFE
AS 'MODULE_PATHNAME', $function$bson_gist_geometry_distance_2d$function$;
-- GIST consistent support functions for bson, which checks if the query can be satisfied by the key stored in index
CREATE OR REPLACE FUNCTION documentdb_api_catalog.bson_gist_geometry_consistent_2d(internal, documentdb_core.bson, integer)
 RETURNS bool
 LANGUAGE C
 PARALLEL SAFE
AS 'MODULE_PATHNAME', $function$bson_gist_geometry_consistent_2d$function$;
-- Geography type GIST support functions for bson
-- Index options function for bson_gist_geography_ops_2d operator class family
CREATE OR REPLACE FUNCTION documentdb_api_catalog.bson_gist_geography_options(internal)
 RETURNS void
 LANGUAGE C
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$bson_gist_geography_options$function$;
-- GIST compress support function for 2dsphere index, this internally uses Postgis GIST compress support function
-- It extract the geography from a `bson` document and compresses it into the gidx type for storage
CREATE OR REPLACE FUNCTION documentdb_api_catalog.bson_gist_geography_compress(internal)
 RETURNS INTERNAL
 LANGUAGE C
 PARALLEL SAFE
AS 'MODULE_PATHNAME', $function$bson_gist_geography_compress$function$;
-- GIST distance support functions for bson, used for ORDER BY and nearest neighbour queries
CREATE OR REPLACE FUNCTION documentdb_api_catalog.bson_gist_geography_distance(internal, documentdb_core.bson, integer)
 RETURNS float8
 LANGUAGE C
 PARALLEL SAFE
AS 'MODULE_PATHNAME', $function$bson_gist_geography_distance$function$;
-- GIST consistent support functions for bson, which checks if the query can be satisfied by the key stored in index
CREATE OR REPLACE FUNCTION documentdb_api_catalog.bson_gist_geography_consistent(internal, documentdb_core.bson, integer)
 RETURNS bool
 LANGUAGE C
 PARALLEL SAFE
AS 'MODULE_PATHNAME', $function$bson_gist_geography_consistent$function$;
-- bson_validate_geography function is used to make the 2dsphere indexes sparse with IS NOT NULL construct
-- and also used with geospatial query operators to match the 2dsphere index predicate
-- for detailed info look at the description of `bson_validate_geography` C function
CREATE OR REPLACE FUNCTION documentdb_api_catalog.bson_validate_geography(
    p_document documentdb_core.bson,
    p_keyPath text)
 RETURNS documentdb_core.bson
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$bson_validate_geography$function$;
-- for detailed info look at the description of `bson_validate_geometry` C function
CREATE OR REPLACE FUNCTION documentdb_api_catalog.bson_validate_geometry(
    p_document documentdb_core.bson,
    p_keyPath text)
 RETURNS documentdb_core.bson
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$bson_validate_geometry$function$;
-- This is a bson type operator class wrapper around `public.gist_geometry_ops_2d` which is implemented for 2d geometries,
-- This operator class has following updates:
-- i) This works for `bson` type instead of `geometry`
-- ii) `compress` support function is changed to support extracting geometries and then converting them to `box2df`
-- iii) This also has `options` support which takes care of storing mongo 2d index options and validating them e.g. bounds
CREATE OPERATOR CLASS documentdb_api_catalog.bson_gist_geometry_ops_2d
 FOR TYPE documentdb_core.bson USING GIST AS
        OPERATOR 23 documentdb_api_catalog.@|-| ,
        FUNCTION 1 documentdb_api_catalog.bson_gist_geometry_consistent_2d (internal, documentdb_core.bson, integer),
        FUNCTION 2 public.geometry_gist_union_2d (bytea, internal),
        FUNCTION 3 documentdb_api_catalog.bson_gist_geometry_2d_compress (internal),
        FUNCTION 4 public.geometry_gist_decompress_2d (internal),
        FUNCTION 5 public.geometry_gist_penalty_2d (internal, internal, internal),
        FUNCTION 6 public.geometry_gist_picksplit_2d (internal, internal),
        FUNCTION 7 public.geometry_gist_same_2d (geom1 public.geometry, geom2 public.geometry, internal),
        FUNCTION 8 documentdb_api_catalog.bson_gist_geometry_distance_2d (internal, documentdb_core.bson, integer),
        FUNCTION 10 (documentdb_core.bson) documentdb_api_catalog.bson_gist_geometry_2d_options(internal),
    STORAGE public.box2df;
-- This is a bson type operator class wrapper around `public.gist_geography_ops` which is implemented for geographies,
-- i) `compress` support function is changed to support extracting geographies and then converting them to `gidx` for storage
-- ii) This also has `options` support which takes care of storing mongo 2dsphjere index options
CREATE OPERATOR CLASS documentdb_api_catalog.bson_gist_geography_ops_2d
 FOR TYPE documentdb_core.bson USING GIST AS
        OPERATOR 23 documentdb_api_catalog.@|-| ,
        OPERATOR 24 documentdb_api_catalog.@|#| ,
        FUNCTION 1 documentdb_api_catalog.bson_gist_geography_consistent (internal, documentdb_core.bson, integer),
        FUNCTION 2 public.geography_gist_union (bytea, internal),
        FUNCTION 3 documentdb_api_catalog.bson_gist_geography_compress (internal),
        FUNCTION 4 public.geography_gist_decompress (internal),
        FUNCTION 5 public.geography_gist_penalty (internal, internal, internal),
        FUNCTION 6 public.geography_gist_picksplit (internal, internal),
        FUNCTION 7 public.geography_gist_same (public.box2d,public.box2d, internal),
        FUNCTION 8 documentdb_api_catalog.bson_gist_geography_distance (internal, documentdb_core.bson, integer),
        FUNCTION 10 (documentdb_core.bson)documentdb_api_catalog.bson_gist_geography_options(internal),
    STORAGE public.gidx;
-- add the distance function to index support for $geoNear
ALTER OPERATOR FAMILY documentdb_api_catalog.bson_gist_geometry_ops_2d USING gist ADD OPERATOR 25 documentdb_api_catalog.<|-|>(documentdb_core.bson, documentdb_core.bson) FOR ORDER BY pg_catalog.float_ops;
ALTER OPERATOR FAMILY documentdb_api_catalog.bson_gist_geography_ops_2d USING gist ADD OPERATOR 25 documentdb_api_catalog.<|-|>(documentdb_core.bson, documentdb_core.bson) FOR ORDER BY pg_catalog.float_ops;
-- Drop the existing $geoNear operator and update the index strategy to be consistent with strategy defined in opclass/bson_gin_common.h
ALTER OPERATOR FAMILY documentdb_api_catalog.bson_gist_geometry_ops_2d USING gist DROP OPERATOR 25 (documentdb_core.bson, documentdb_core.bson);
ALTER OPERATOR FAMILY documentdb_api_catalog.bson_gist_geography_ops_2d USING gist DROP OPERATOR 25 (documentdb_core.bson, documentdb_core.bson);
ALTER OPERATOR FAMILY documentdb_api_catalog.bson_gist_geometry_ops_2d USING gist ADD OPERATOR 30 documentdb_api_catalog.<|-|>(documentdb_core.bson, documentdb_core.bson) FOR ORDER BY pg_catalog.float_ops;
ALTER OPERATOR FAMILY documentdb_api_catalog.bson_gist_geography_ops_2d USING gist ADD OPERATOR 30 documentdb_api_catalog.<|-|>(documentdb_core.bson, documentdb_core.bson) FOR ORDER BY pg_catalog.float_ops;
 -- Add the range operator to the index support for $geoNear
 ALTER OPERATOR FAMILY documentdb_api_catalog.bson_gist_geometry_ops_2d USING gist ADD OPERATOR 31 documentdb_api_internal.@|><|(documentdb_core.bson, documentdb_core.bson);
 ALTER OPERATOR FAMILY documentdb_api_catalog.bson_gist_geography_ops_2d USING gist ADD OPERATOR 31 documentdb_api_internal.@|><|(documentdb_core.bson, documentdb_core.bson);
CREATE TYPE documentdb_api_catalog.shard_key_and_document AS
(
    shard_key_value int8,
    document documentdb_core.bson
);
CREATE OR REPLACE FUNCTION documentdb_api_catalog.gin_bson_pre_consistent(internal,smallint,documentdb_core.bson,int,internal,internal,internal,internal)
 RETURNS void
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$gin_bson_pre_consistent$function$;
CREATE OR REPLACE FUNCTION documentdb_api_catalog.gin_bson_exclusion_pre_consistent(internal,smallint,documentdb_api_catalog.shard_key_and_document,int,internal,internal,internal,internal)
 RETURNS void
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$gin_bson_exclusion_pre_consistent$function$;
CREATE OR REPLACE FUNCTION documentdb_api_catalog.gin_bson_can_pre_consistent(smallint, documentdb_core.bson, int, internal, internal, internal)
 RETURNS bool
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$gin_bson_can_pre_consistent$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_unique_exclusion_index_equal(
    documentdb_api_catalog.shard_key_and_document, documentdb_api_catalog.shard_key_and_document)
 RETURNS boolean
 LANGUAGE C
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$bson_unique_exclusion_index_equal$function$;
CREATE FUNCTION documentdb_api_internal.gin_bson_exclusion_extract_value(documentdb_api_catalog.shard_key_and_document, internal)
 RETURNS internal
 LANGUAGE C STRICT IMMUTABLE
AS 'MODULE_PATHNAME', $function$gin_bson_exclusion_extract_value$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.gin_bson_exclusion_options(internal)
 RETURNS void
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$gin_bson_exclusion_options$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.gin_bson_exclusion_extract_query(documentdb_api_catalog.shard_key_and_document, internal, int2, internal, internal, internal, internal)
 RETURNS void
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$gin_bson_exclusion_extract_query$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.gin_bson_exclusion_consistent(internal, smallint, anyelement, integer, internal, internal)
 RETURNS boolean
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$gin_bson_exclusion_consistent$function$;
CREATE OPERATOR documentdb_api_catalog.=
(
    LEFTARG = documentdb_api_catalog.shard_key_and_document,
    RIGHTARG = documentdb_api_catalog.shard_key_and_document,
    PROCEDURE = documentdb_api_internal.bson_unique_exclusion_index_equal,
    COMMUTATOR = OPERATOR(documentdb_api_catalog.=)
);
CREATE OR REPLACE FUNCTION documentdb_api_internal.generate_unique_shard_document(p_document documentdb_core.bson, p_shard_key_value bigint, p_unique_spec documentdb_core.bson, p_sparse boolean)
 RETURNS documentdb_core.bson
 LANGUAGE C STRICT IMMUTABLE PARALLEL SAFE
AS 'MODULE_PATHNAME', $function$generate_unique_shard_document$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_unique_shard_path_equal(documentdb_core.bson, documentdb_core.bson)
 RETURNS boolean
 LANGUAGE C STRICT IMMUTABLE PARALLEL SAFE
AS 'MODULE_PATHNAME', $function$bson_unique_shard_path_equal$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.gin_bson_unique_shard_extract_value(documentdb_core.bson, internal)
 RETURNS internal
 LANGUAGE C STRICT IMMUTABLE
AS 'MODULE_PATHNAME', $function$gin_bson_unique_shard_extract_value$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.gin_bson_unique_shard_extract_query(documentdb_core.bson, internal, int2, internal, internal, internal, internal)
 RETURNS void
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$gin_bson_unique_shard_extract_query$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.gin_bson_unique_shard_pre_consistent(internal,smallint,documentdb_core.bson,int,internal,internal,internal,internal)
 RETURNS void
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$gin_bson_unique_shard_pre_consistent$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.gin_bson_unique_shard_consistent(internal, smallint, anyelement, integer, internal, internal)
 RETURNS boolean
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$gin_bson_unique_shard_consistent$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_unique_index_equal(documentdb_core.bson, documentdb_core.bson)
 RETURNS bool
 LANGUAGE C
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$bson_unique_index_term_equal$function$;
CREATE OPERATOR documentdb_api_internal.=#=
(
    LEFTARG = documentdb_core.bson,
    RIGHTARG = documentdb_core.bson,
    PROCEDURE = documentdb_api_internal.bson_unique_shard_path_equal,
    COMMUTATOR = OPERATOR(documentdb_api_internal.=#=)
);
CREATE OPERATOR documentdb_api_catalog.@= (
    LEFTARG = documentdb_core.bson,
    RIGHTARG = documentdb_core.bson,
    PROCEDURE = documentdb_api_catalog.bson_dollar_eq,
    RESTRICT = documentdb_core.bson_operator_selectivity,
    NEGATOR = OPERATOR(documentdb_api_catalog.@!=)
);
CREATE OPERATOR documentdb_api_catalog.@!= (
    LEFTARG = documentdb_core.bson,
    RIGHTARG = documentdb_core.bson,
    PROCEDURE = documentdb_api_catalog.bson_dollar_ne,
    RESTRICT = documentdb_core.bson_operator_selectivity,
    NEGATOR = OPERATOR(documentdb_api_catalog.@=)
);
CREATE OPERATOR documentdb_api_catalog.@< (
    LEFTARG = documentdb_core.bson,
    RIGHTARG = documentdb_core.bson,
    PROCEDURE = documentdb_api_catalog.bson_dollar_lt,
    RESTRICT = documentdb_core.bson_operator_selectivity
);
CREATE OPERATOR documentdb_api_catalog.@<= (
    LEFTARG = documentdb_core.bson,
    RIGHTARG = documentdb_core.bson,
    PROCEDURE = documentdb_api_catalog.bson_dollar_lte,
    RESTRICT = documentdb_core.bson_operator_selectivity
);
CREATE OPERATOR documentdb_api_catalog.@> (
    LEFTARG = documentdb_core.bson,
    RIGHTARG = documentdb_core.bson,
    PROCEDURE = documentdb_api_catalog.bson_dollar_gt,
    RESTRICT = documentdb_core.bson_operator_selectivity
);
CREATE OPERATOR documentdb_api_catalog.@>= (
    LEFTARG = documentdb_core.bson,
    RIGHTARG = documentdb_core.bson,
    PROCEDURE = documentdb_api_catalog.bson_dollar_gte,
    RESTRICT = documentdb_core.bson_operator_selectivity
);
CREATE OPERATOR documentdb_api_catalog.@*= (
    LEFTARG = documentdb_core.bson,
    RIGHTARG = documentdb_core.bson,
    PROCEDURE = documentdb_api_catalog.bson_dollar_in,
    RESTRICT = documentdb_core.bson_operator_selectivity,
    NEGATOR = OPERATOR(documentdb_api_catalog.@!*=)
);
CREATE OPERATOR documentdb_api_catalog.@!*= (
    LEFTARG = documentdb_core.bson,
    RIGHTARG = documentdb_core.bson,
    PROCEDURE = documentdb_api_catalog.bson_dollar_nin,
    RESTRICT = documentdb_core.bson_operator_selectivity,
    NEGATOR = OPERATOR(documentdb_api_catalog.@*=)
);
CREATE OPERATOR documentdb_api_catalog.@~ (
    LEFTARG = documentdb_core.bson,
    RIGHTARG = documentdb_core.bson,
    PROCEDURE = documentdb_api_catalog.bson_dollar_regex,
    RESTRICT = documentdb_core.bson_operator_selectivity
);
CREATE OPERATOR documentdb_api_catalog.@% (
    LEFTARG = documentdb_core.bson,
    RIGHTARG = documentdb_core.bson,
    PROCEDURE = documentdb_api_catalog.bson_dollar_mod,
    RESTRICT = documentdb_core.bson_operator_selectivity
);
CREATE OPERATOR documentdb_api_catalog.@? (
    LEFTARG = documentdb_core.bson,
    RIGHTARG = documentdb_core.bson,
    PROCEDURE = documentdb_api_catalog.bson_dollar_exists,
    RESTRICT = documentdb_core.bson_operator_selectivity
);
CREATE OPERATOR documentdb_api_catalog.@@# (
    LEFTARG = documentdb_core.bson,
    RIGHTARG = documentdb_core.bson,
    PROCEDURE = documentdb_api_catalog.bson_dollar_size,
    RESTRICT = documentdb_core.bson_operator_selectivity
);
CREATE OPERATOR documentdb_api_catalog.@# (
    LEFTARG = documentdb_core.bson,
    RIGHTARG = documentdb_core.bson,
    PROCEDURE = documentdb_api_catalog.bson_dollar_type,
    RESTRICT = documentdb_core.bson_operator_selectivity
);
CREATE OPERATOR documentdb_api_catalog.@&= (
    LEFTARG = documentdb_core.bson,
    RIGHTARG = documentdb_core.bson,
    PROCEDURE = documentdb_api_catalog.bson_dollar_all,
    RESTRICT = documentdb_core.bson_operator_selectivity
);
CREATE OPERATOR documentdb_api_catalog.@#? (
    LEFTARG = documentdb_core.bson,
    RIGHTARG = documentdb_core.bson,
    PROCEDURE = documentdb_api_catalog.bson_dollar_elemmatch,
    RESTRICT = documentdb_core.bson_operator_selectivity
);
CREATE OPERATOR documentdb_api_catalog.@!& (
    LEFTARG = documentdb_core.bson,
    RIGHTARG = documentdb_core.bson,
    PROCEDURE = documentdb_api_catalog.bson_dollar_bits_all_clear,
    RESTRICT = documentdb_core.bson_operator_selectivity
);
CREATE OPERATOR documentdb_api_catalog.@!| (
    LEFTARG = documentdb_core.bson,
    RIGHTARG = documentdb_core.bson,
    PROCEDURE = documentdb_api_catalog.bson_dollar_bits_any_clear,
    RESTRICT = documentdb_core.bson_operator_selectivity
);
CREATE OPERATOR documentdb_api_catalog.@& (
    LEFTARG = documentdb_core.bson,
    RIGHTARG = documentdb_core.bson,
    PROCEDURE = documentdb_api_catalog.bson_dollar_bits_all_set,
    RESTRICT = documentdb_core.bson_operator_selectivity
);
CREATE OPERATOR documentdb_api_catalog.@| (
    LEFTARG = documentdb_core.bson,
    RIGHTARG = documentdb_core.bson,
    PROCEDURE = documentdb_api_catalog.bson_dollar_bits_any_set,
    RESTRICT = documentdb_core.bson_operator_selectivity
);
CREATE OPERATOR documentdb_api_catalog.=?= (
    LEFTARG = documentdb_core.bson,
    RIGHTARG = documentdb_core.bson,
    PROCEDURE = documentdb_core.bson_unique_index_equal,
    COMMUTATOR = OPERATOR(documentdb_api_catalog.=?=)
);
CREATE OPERATOR documentdb_api_catalog.@<> (
    LEFTARG = documentdb_core.bson,
    RIGHTARG = documentdb_core.bson,
    PROCEDURE = documentdb_api_internal.bson_dollar_range
);
DROP OPERATOR IF EXISTS documentdb_api_catalog.=?=(documentdb_core.bson, documentdb_core.bson);
CREATE OPERATOR documentdb_api_catalog.=?= (
    LEFTARG = documentdb_core.bson,
    RIGHTARG = documentdb_core.bson,
    PROCEDURE = documentdb_api_internal.bson_unique_index_equal,
    COMMUTATOR = OPERATOR(documentdb_api_catalog.=?=)
);
ALTER OPERATOR documentdb_api_catalog.@=(documentdb_core.bson, documentdb_core.bson) SET (RESTRICT = documentdb_api_internal.bson_dollar_selectivity);
ALTER OPERATOR documentdb_api_catalog.@!=(documentdb_core.bson, documentdb_core.bson) SET (RESTRICT = documentdb_api_internal.bson_dollar_selectivity);
ALTER OPERATOR documentdb_api_catalog.@<(documentdb_core.bson, documentdb_core.bson) SET (RESTRICT = documentdb_api_internal.bson_dollar_selectivity);
ALTER OPERATOR documentdb_api_catalog.@<=(documentdb_core.bson, documentdb_core.bson) SET (RESTRICT = documentdb_api_internal.bson_dollar_selectivity);
ALTER OPERATOR documentdb_api_catalog.@>(documentdb_core.bson, documentdb_core.bson) SET (RESTRICT = documentdb_api_internal.bson_dollar_selectivity);
ALTER OPERATOR documentdb_api_catalog.@>=(documentdb_core.bson, documentdb_core.bson) SET (RESTRICT = documentdb_api_internal.bson_dollar_selectivity);
ALTER OPERATOR documentdb_api_catalog.@*=(documentdb_core.bson, documentdb_core.bson) SET (RESTRICT = documentdb_api_internal.bson_dollar_selectivity);
ALTER OPERATOR documentdb_api_catalog.@!*=(documentdb_core.bson, documentdb_core.bson) SET (RESTRICT = documentdb_api_internal.bson_dollar_selectivity);
ALTER OPERATOR documentdb_api_catalog.@~(documentdb_core.bson, documentdb_core.bson) SET (RESTRICT = documentdb_api_internal.bson_dollar_selectivity);
ALTER OPERATOR documentdb_api_catalog.@%(documentdb_core.bson, documentdb_core.bson) SET (RESTRICT = documentdb_api_internal.bson_dollar_selectivity);
ALTER OPERATOR documentdb_api_catalog.@?(documentdb_core.bson, documentdb_core.bson) SET (RESTRICT = documentdb_api_internal.bson_dollar_selectivity);
ALTER OPERATOR documentdb_api_catalog.@@#(documentdb_core.bson, documentdb_core.bson) SET (RESTRICT = documentdb_api_internal.bson_dollar_selectivity);
ALTER OPERATOR documentdb_api_catalog.@#(documentdb_core.bson, documentdb_core.bson) SET (RESTRICT = documentdb_api_internal.bson_dollar_selectivity);
ALTER OPERATOR documentdb_api_catalog.@&=(documentdb_core.bson, documentdb_core.bson) SET (RESTRICT = documentdb_api_internal.bson_dollar_selectivity);
ALTER OPERATOR documentdb_api_catalog.@#?(documentdb_core.bson, documentdb_core.bson) SET (RESTRICT = documentdb_api_internal.bson_dollar_selectivity);
ALTER OPERATOR documentdb_api_catalog.@!&(documentdb_core.bson, documentdb_core.bson) SET (RESTRICT = documentdb_api_internal.bson_dollar_selectivity);
ALTER OPERATOR documentdb_api_catalog.@!|(documentdb_core.bson, documentdb_core.bson) SET (RESTRICT = documentdb_api_internal.bson_dollar_selectivity);
ALTER OPERATOR documentdb_api_catalog.@&(documentdb_core.bson, documentdb_core.bson) SET (RESTRICT = documentdb_api_internal.bson_dollar_selectivity);
ALTER OPERATOR documentdb_api_catalog.@|(documentdb_core.bson, documentdb_core.bson) SET (RESTRICT = documentdb_api_internal.bson_dollar_selectivity);
ALTER OPERATOR documentdb_api_catalog.#=(documentdb_core.bson, documentdb_core.bsonquery) SET (RESTRICT = documentdb_api_internal.bson_dollar_selectivity);
ALTER OPERATOR documentdb_api_catalog.#>(documentdb_core.bson, documentdb_core.bsonquery) SET (RESTRICT = documentdb_api_internal.bson_dollar_selectivity);
ALTER OPERATOR documentdb_api_catalog.#>= (documentdb_core.bson, documentdb_core.bsonquery) SET (RESTRICT = documentdb_api_internal.bson_dollar_selectivity);
ALTER OPERATOR documentdb_api_catalog.#< (documentdb_core.bson, documentdb_core.bsonquery) SET (RESTRICT = documentdb_api_internal.bson_dollar_selectivity);
ALTER OPERATOR documentdb_api_catalog.#<= (documentdb_core.bson, documentdb_core.bsonquery) SET (RESTRICT = documentdb_api_internal.bson_dollar_selectivity);
CREATE OPERATOR documentdb_api_internal.@!>
(
    LEFTARG = documentdb_core.bson,
    RIGHTARG = documentdb_core.bson,
    PROCEDURE = documentdb_api_internal.bson_dollar_not_gt,
    RESTRICT = documentdb_api_internal.bson_dollar_selectivity
);
CREATE OPERATOR documentdb_api_internal.@!>=
(
    LEFTARG = documentdb_core.bson,
    RIGHTARG = documentdb_core.bson,
    PROCEDURE = documentdb_api_internal.bson_dollar_not_gte,
    RESTRICT = documentdb_api_internal.bson_dollar_selectivity
);
CREATE OPERATOR documentdb_api_internal.@!<
(
    LEFTARG = documentdb_core.bson,
    RIGHTARG = documentdb_core.bson,
    PROCEDURE = documentdb_api_internal.bson_dollar_not_lt,
    RESTRICT = documentdb_api_internal.bson_dollar_selectivity
);
CREATE OPERATOR documentdb_api_internal.@!<=
(
    LEFTARG = documentdb_core.bson,
    RIGHTARG = documentdb_core.bson,
    PROCEDURE = documentdb_api_internal.bson_dollar_not_lte,
    RESTRICT = documentdb_api_internal.bson_dollar_selectivity
);
CREATE OR REPLACE FUNCTION documentdb_api_catalog.documentdbrumhandler(internal)
 RETURNS index_am_handler
 LANGUAGE C
AS 'MODULE_PATHNAME', $function$extensionrumhandler$function$;
CREATE ACCESS METHOD documentdb_rum TYPE INDEX HANDLER documentdb_api_catalog.documentdbrumhandler;
CREATE OPERATOR CLASS documentdb_api_internal.bson_rum_unique_shard_path_ops
    FOR TYPE documentdb_core.bson using documentdb_rum AS
        OPERATOR 1 documentdb_api_internal.=#= (documentdb_core.bson, documentdb_core.bson),
        FUNCTION 1 uuid_cmp(uuid,uuid),
        FUNCTION 2 documentdb_api_internal.gin_bson_unique_shard_extract_value(documentdb_core.bson, internal),
        FUNCTION 3 documentdb_api_internal.gin_bson_unique_shard_extract_query(documentdb_core.bson, internal, int2, internal, internal, internal, internal),
        FUNCTION 4 documentdb_api_internal.gin_bson_unique_shard_consistent(internal, int2, anyelement, int4, internal, internal),
        FUNCTION 7 (documentdb_core.bson) documentdb_api_internal.gin_bson_unique_shard_pre_consistent(internal,smallint,documentdb_core.bson,int,internal,internal,internal,internal),
    STORAGE uuid;
-- for Unique indexes, we need to add shard key into the unique index filter
-- To ensure that we have these, we pull in the uuid operator class
-- similar to the btree_gin extension.
CREATE OPERATOR CLASS documentdb_api_catalog.bson_rum_exclusion_ops
    FOR TYPE documentdb_api_catalog.shard_key_and_document USING documentdb_rum AS
        -- we only add Btree equal (since we don't need to support others for Unique)
        OPERATOR 3 documentdb_api_catalog.= ,
        FUNCTION 1 uuid_cmp(uuid,uuid),
        FUNCTION 2 documentdb_api_internal.gin_bson_exclusion_extract_value(documentdb_api_catalog.shard_key_and_document, internal),
        FUNCTION 3 documentdb_api_internal.gin_bson_exclusion_extract_query(documentdb_api_catalog.shard_key_and_document, internal, int2, internal, internal, internal, internal),
        FUNCTION 4 documentdb_api_internal.gin_bson_exclusion_consistent(internal, int2, anyelement, int4, internal, internal),
        FUNCTION 7 (documentdb_api_catalog.shard_key_and_document) documentdb_api_catalog.gin_bson_exclusion_pre_consistent(internal,smallint,documentdb_api_catalog.shard_key_and_document,int,internal,internal,internal,internal),
        FUNCTION 11 (documentdb_api_catalog.shard_key_and_document) documentdb_api_internal.gin_bson_exclusion_options(internal),
    STORAGE uuid;
CREATE OPERATOR documentdb_api_catalog.@#% (
    LEFTARG = documentdb_core.bson,
    RIGHTARG = tsquery,
    PROCEDURE = documentdb_api_internal.bson_text_tsquery,
    RESTRICT = documentdb_core.bson_operator_selectivity
);
DROP FUNCTION IF EXISTS documentdb_api_internal.rum_bson_single_path_extract_tsvector;
CREATE OR REPLACE FUNCTION documentdb_api_internal.rum_bson_single_path_extract_tsvector(documentdb_core.bson, internal, internal, internal, internal)
 RETURNS internal
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$rum_bson_single_path_extract_tsvector$function$;
DROP FUNCTION IF EXISTS documentdb_api_internal.rum_bson_text_path_options;
CREATE OR REPLACE FUNCTION documentdb_api_internal.rum_bson_text_path_options(internal)
 RETURNS void
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$rum_bson_text_path_options$function$;
-- This is a variant of public.rum_tsvector_ops. However, this takes 'bson' as an input so we can hook it up against our
-- index selection and handling of array paths etc. We override the extract tsvector where we take the bson, generate the tsvector
-- and generate the 'text' terms for the index (just like rum would). The query path remains identical. Note that the terms in the
-- index are still text.
CREATE OPERATOR CLASS documentdb_api_catalog.bson_rum_text_path_ops
    FOR TYPE documentdb_core.bson using documentdb_rum AS
        OPERATOR 1 documentdb_api_catalog.@#% (documentdb_core.bson, tsquery),
        FUNCTION 1 gin_cmp_tslexeme(text, text),
        FUNCTION 2 documentdb_api_internal.rum_bson_single_path_extract_tsvector(documentdb_core.bson,internal,internal,internal,internal),
        FUNCTION 3 public.rum_extract_tsquery(tsquery,internal,smallint,internal,internal,internal,internal),
        FUNCTION 4 public.rum_tsquery_consistent(internal,smallint,tsvector,int,internal,internal,internal,internal),
        FUNCTION 5 gin_cmp_prefix(text,text,smallint,internal),
        FUNCTION 6 public.rum_tsvector_config(internal),
        FUNCTION 7 public.rum_tsquery_pre_consistent(internal,smallint,tsvector,int,internal,internal,internal,internal),
        FUNCTION 8 public.rum_tsquery_distance(internal,smallint,tsvector,int,internal,internal,internal,internal,internal),
        FUNCTION 10 public.rum_ts_join_pos(internal, internal),
        FUNCTION 11 (documentdb_core.bson) documentdb_api_internal.rum_bson_text_path_options(internal),
    STORAGE text;
-- Note that the functions here have the prefix 'gin' even though they may be used on the RUM index.
-- This is because the RUM docs also use the same constants/functions as GIN extensibility for all existing functionality.
-- Consequently we reuse the gin prefix for functionality shared with GIN.
CREATE OR REPLACE FUNCTION documentdb_api_catalog.gin_bson_compare(bytea, bytea)
 RETURNS bool
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$gin_bson_compare$function$;
CREATE OR REPLACE FUNCTION documentdb_api_catalog.gin_bson_extract_query(documentdb_core.bson, internal, int2, internal, internal, internal, internal)
 RETURNS internal
 LANGUAGE c
 PARALLEL SAFE STABLE
AS 'MODULE_PATHNAME', $function$gin_bson_extract_query$function$;
CREATE OR REPLACE FUNCTION documentdb_api_catalog.gin_bson_compare_partial(bytea, bytea, int2, internal)
 RETURNS int4
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
 AS 'MODULE_PATHNAME', $function$gin_bson_compare_partial$function$;
CREATE OR REPLACE FUNCTION documentdb_api_catalog.gin_bson_consistent(internal, smallint, anyelement, integer, internal, internal)
 RETURNS boolean
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$gin_bson_consistent$function$;
-- Note that the functions here have the prefix 'gin' even though they may be used on the RUM index.
-- This is because the RUM docs also use the same constants/functions as GIN extensibility for all existing functionality.
-- Consequently we reuse the gin prefix for functionality shared with GIN.
CREATE OR REPLACE FUNCTION documentdb_api_catalog.gin_bson_single_path_extract_value(documentdb_core.bson, internal)
 RETURNS internal
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$gin_bson_single_path_extract_value$function$;
CREATE OR REPLACE FUNCTION documentdb_api_catalog.gin_bson_single_path_options(internal)
 RETURNS void
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$gin_bson_single_path_options$function$;
CREATE OPERATOR CLASS documentdb_api_catalog.bson_rum_single_path_ops
    DEFAULT FOR TYPE documentdb_core.bson using documentdb_rum AS
        OPERATOR 1 documentdb_api_catalog.@= (documentdb_core.bson, documentdb_core.bson),
        OPERATOR 2 documentdb_api_catalog.@> (documentdb_core.bson, documentdb_core.bson),
        OPERATOR 3 documentdb_api_catalog.@>= (documentdb_core.bson, documentdb_core.bson),
        OPERATOR 4 documentdb_api_catalog.@< (documentdb_core.bson, documentdb_core.bson),
        OPERATOR 5 documentdb_api_catalog.@<= (documentdb_core.bson, documentdb_core.bson),
        OPERATOR 6 documentdb_api_catalog.@*= (documentdb_core.bson, documentdb_core.bson),
        OPERATOR 7 documentdb_api_catalog.@!= (documentdb_core.bson, documentdb_core.bson),
        OPERATOR 8 documentdb_api_catalog.@!*= (documentdb_core.bson, documentdb_core.bson),
        OPERATOR 9 documentdb_api_catalog.@~ (documentdb_core.bson, documentdb_core.bson),
        OPERATOR 10 documentdb_api_catalog.@? (documentdb_core.bson, documentdb_core.bson),
        OPERATOR 11 documentdb_api_catalog.@@# (documentdb_core.bson, documentdb_core.bson),
        OPERATOR 12 documentdb_api_catalog.@# (documentdb_core.bson, documentdb_core.bson),
        OPERATOR 13 documentdb_api_catalog.@&= (documentdb_core.bson, documentdb_core.bson),
        OPERATOR 14 documentdb_api_catalog.=?= (documentdb_core.bson, documentdb_core.bson),
        OPERATOR 15 documentdb_api_catalog.@!& (documentdb_core.bson, documentdb_core.bson),
        OPERATOR 16 documentdb_api_catalog.@!| (documentdb_core.bson, documentdb_core.bson),
        OPERATOR 17 documentdb_api_catalog.@#? (documentdb_core.bson, documentdb_core.bson),
        OPERATOR 18 documentdb_api_catalog.@& (documentdb_core.bson, documentdb_core.bson),
        OPERATOR 19 documentdb_api_catalog.@| (documentdb_core.bson, documentdb_core.bson),
        OPERATOR 20 documentdb_api_catalog.@% (documentdb_core.bson, documentdb_core.bson),
        FUNCTION 1 documentdb_api_catalog.gin_bson_compare(bytea, bytea),
        FUNCTION 2 documentdb_api_catalog.gin_bson_single_path_extract_value(documentdb_core.bson, internal),
        FUNCTION 3 documentdb_api_catalog.gin_bson_extract_query(documentdb_core.bson, internal, int2, internal, internal, internal, internal),
        FUNCTION 4 documentdb_api_catalog.gin_bson_consistent(internal, int2, anyelement, int4, internal, internal),
        FUNCTION 5 documentdb_api_catalog.gin_bson_compare_partial(bytea, bytea, int2, internal),
        FUNCTION 11 (documentdb_core.bson) documentdb_api_catalog.gin_bson_single_path_options(internal),
    STORAGE bytea;
-- Note that the functions here have the prefix 'gin' even though they may be used on the RUM index.
-- This is because the RUM docs also use the same constants/functions as GIN extensibility for all existing functionality.
-- Consequently we reuse the gin prefix for functionality shared with GIN.
CREATE OR REPLACE FUNCTION documentdb_api_catalog.gin_bson_wildcard_project_extract_value(documentdb_core.bson, internal)
 RETURNS internal
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$gin_bson_wildcard_project_extract_value$function$;
CREATE OR REPLACE FUNCTION documentdb_api_catalog.gin_bson_wildcard_project_options(internal)
 RETURNS void
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$gin_bson_wildcard_project_options$function$;
CREATE OPERATOR CLASS documentdb_api_catalog.bson_rum_wildcard_project_path_ops
    FOR TYPE documentdb_core.bson using documentdb_rum AS
        OPERATOR 1 documentdb_api_catalog.@= (documentdb_core.bson, documentdb_core.bson),
        OPERATOR 2 documentdb_api_catalog.@> (documentdb_core.bson, documentdb_core.bson),
        OPERATOR 3 documentdb_api_catalog.@>= (documentdb_core.bson, documentdb_core.bson),
        OPERATOR 4 documentdb_api_catalog.@< (documentdb_core.bson, documentdb_core.bson),
        OPERATOR 5 documentdb_api_catalog.@<= (documentdb_core.bson, documentdb_core.bson),
        OPERATOR 6 documentdb_api_catalog.@*= (documentdb_core.bson, documentdb_core.bson),
        OPERATOR 7 documentdb_api_catalog.@!= (documentdb_core.bson, documentdb_core.bson),
        OPERATOR 8 documentdb_api_catalog.@!*= (documentdb_core.bson, documentdb_core.bson),
        OPERATOR 9 documentdb_api_catalog.@~ (documentdb_core.bson, documentdb_core.bson),
        OPERATOR 10 documentdb_api_catalog.@? (documentdb_core.bson, documentdb_core.bson),
        OPERATOR 11 documentdb_api_catalog.@@# (documentdb_core.bson, documentdb_core.bson),
        OPERATOR 12 documentdb_api_catalog.@# (documentdb_core.bson, documentdb_core.bson),
        OPERATOR 13 documentdb_api_catalog.@&= (documentdb_core.bson, documentdb_core.bson),
-- skip unique index equal for wildcard since unique is not supported for wildcard
-- OPERATOR 14 documentdb_api_catalog.=?= (documentdb_core.bson, documentdb_core.bson),
        OPERATOR 15 documentdb_api_catalog.@!& (documentdb_core.bson, documentdb_core.bson),
        OPERATOR 16 documentdb_api_catalog.@!| (documentdb_core.bson, documentdb_core.bson),
        OPERATOR 17 documentdb_api_catalog.@#? (documentdb_core.bson, documentdb_core.bson),
        OPERATOR 18 documentdb_api_catalog.@& (documentdb_core.bson, documentdb_core.bson),
        OPERATOR 19 documentdb_api_catalog.@| (documentdb_core.bson, documentdb_core.bson),
        OPERATOR 20 documentdb_api_catalog.@% (documentdb_core.bson, documentdb_core.bson),
        FUNCTION 1 documentdb_api_catalog.gin_bson_compare(bytea, bytea),
        FUNCTION 2 documentdb_api_catalog.gin_bson_wildcard_project_extract_value(documentdb_core.bson, internal),
        FUNCTION 3 documentdb_api_catalog.gin_bson_extract_query(documentdb_core.bson, internal, int2, internal, internal, internal, internal),
        FUNCTION 4 documentdb_api_catalog.gin_bson_consistent(internal, int2, anyelement, int4, internal, internal),
        FUNCTION 5 documentdb_api_catalog.gin_bson_compare_partial(bytea, bytea, int2, internal),
        FUNCTION 11 (documentdb_core.bson) documentdb_api_catalog.gin_bson_wildcard_project_options(internal),
    STORAGE bytea;
CREATE FUNCTION documentdb_api_internal.gin_bson_hashed_extract_value(documentdb_core.bson, internal)
 RETURNS internal
 LANGUAGE C STRICT IMMUTABLE
AS 'MODULE_PATHNAME', $function$gin_bson_hashed_extract_value$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.gin_bson_hashed_options(internal)
 RETURNS void
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$gin_bson_hashed_options$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.gin_bson_hashed_extract_query(documentdb_core.bson, internal, int2, internal, internal, internal, internal)
 RETURNS void
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$gin_bson_hashed_extract_query$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.gin_bson_hashed_consistent(internal, smallint, anyelement, integer, internal, internal)
 RETURNS boolean
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$gin_bson_hashed_consistent$function$;
CREATE OPERATOR CLASS documentdb_api_catalog.documentdb_rum_hashed_ops
    FOR TYPE documentdb_core.bson USING documentdb_rum AS
        -- hashed index only supports the equal and in operators
        OPERATOR 1 documentdb_api_catalog.@=,
        OPERATOR 6 documentdb_api_catalog.@*= (documentdb_core.bson, documentdb_core.bson),
        FUNCTION 1 btint8cmp(int8,int8),
        FUNCTION 2 documentdb_api_internal.gin_bson_hashed_extract_value(documentdb_core.bson, internal),
        FUNCTION 3 documentdb_api_internal.gin_bson_hashed_extract_query(documentdb_core.bson, internal, int2, internal, internal, internal, internal),
        FUNCTION 4 documentdb_api_internal.gin_bson_hashed_consistent(internal, int2, anyelement, int4, internal, internal),
        FUNCTION 11 (documentdb_core.bson) documentdb_api_internal.gin_bson_hashed_options(internal),
    STORAGE int8;
ALTER OPERATOR FAMILY documentdb_api_catalog.bson_rum_single_path_ops USING documentdb_rum ADD OPERATOR 26 documentdb_api_internal.@!> (documentdb_core.bson, documentdb_core.bson);
ALTER OPERATOR FAMILY documentdb_api_catalog.bson_rum_single_path_ops USING documentdb_rum ADD OPERATOR 27 documentdb_api_internal.@!>= (documentdb_core.bson, documentdb_core.bson);
ALTER OPERATOR FAMILY documentdb_api_catalog.bson_rum_single_path_ops USING documentdb_rum ADD OPERATOR 28 documentdb_api_internal.@!< (documentdb_core.bson, documentdb_core.bson);
ALTER OPERATOR FAMILY documentdb_api_catalog.bson_rum_single_path_ops USING documentdb_rum ADD OPERATOR 29 documentdb_api_internal.@!<= (documentdb_core.bson, documentdb_core.bson);
ALTER OPERATOR FAMILY documentdb_api_catalog.bson_rum_wildcard_project_path_ops USING documentdb_rum ADD OPERATOR 26 documentdb_api_internal.@!> (documentdb_core.bson, documentdb_core.bson);
ALTER OPERATOR FAMILY documentdb_api_catalog.bson_rum_wildcard_project_path_ops USING documentdb_rum ADD OPERATOR 27 documentdb_api_internal.@!>= (documentdb_core.bson, documentdb_core.bson);
ALTER OPERATOR FAMILY documentdb_api_catalog.bson_rum_wildcard_project_path_ops USING documentdb_rum ADD OPERATOR 28 documentdb_api_internal.@!< (documentdb_core.bson, documentdb_core.bson);
ALTER OPERATOR FAMILY documentdb_api_catalog.bson_rum_wildcard_project_path_ops USING documentdb_rum ADD OPERATOR 29 documentdb_api_internal.@!<= (documentdb_core.bson, documentdb_core.bson);
ALTER OPERATOR FAMILY documentdb_api_catalog.bson_rum_single_path_ops USING documentdb_rum
    ADD OPERATOR 25 documentdb_api_catalog.@<> (documentdb_core.bson, documentdb_core.bson);
ALTER OPERATOR FAMILY documentdb_api_catalog.bson_rum_wildcard_project_path_ops USING documentdb_rum
    ADD OPERATOR 25 documentdb_api_catalog.@<> (documentdb_core.bson, documentdb_core.bson);
CREATE OR REPLACE FUNCTION documentdb_api_internal.aggregation_support(internal)
 RETURNS internal
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $$command_aggregation_support$$;
DROP FUNCTION IF EXISTS documentdb_api_catalog.bson_aggregation_pipeline;
-- This function is the Mongo aggregation pipeline function.
-- It is a wrapper function that passes the aggregation pipeline from the GW to the backend
-- such that the planner phase can replace the parameterized value in the planning phase.
CREATE OR REPLACE FUNCTION documentdb_api_catalog.bson_aggregation_pipeline(
    databaseName text,
    aggregationPipeline documentdb_core.bson,
    OUT document documentdb_core.bson)
 RETURNS SETOF documentdb_core.bson
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
 SUPPORT documentdb_api_internal.aggregation_support
AS 'MODULE_PATHNAME', $function$command_bson_aggregation_pipeline$function$;
DROP FUNCTION IF EXISTS documentdb_api_catalog.bson_aggregation_find;
-- This function is the Mongo find query function.
-- It is a wrapper function that passes the aggregation pipeline from the GW to the backend
-- such that the planner phase can replace the parameterized value in the planning phase.
CREATE OR REPLACE FUNCTION documentdb_api_catalog.bson_aggregation_find(
    databaseName text,
    findSpec documentdb_core.bson,
    OUT document documentdb_core.bson)
 RETURNS SETOF documentdb_core.bson
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
 SUPPORT documentdb_api_internal.aggregation_support
AS 'MODULE_PATHNAME', $function$command_bson_aggregation_pipeline$function$;
DROP FUNCTION IF EXISTS documentdb_api_catalog.bson_aggregation_count;
-- This function is the Mongo count query function.
-- It is a wrapper function that passes the aggregation pipeline from the GW to the backend
-- such that the planner phase can replace the parameterized value in the planning phase.
CREATE OR REPLACE FUNCTION documentdb_api_catalog.bson_aggregation_count(
    databaseName text,
    countSpec documentdb_core.bson,
    OUT document documentdb_core.bson)
 RETURNS SETOF documentdb_core.bson
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
 SUPPORT documentdb_api_internal.aggregation_support
AS 'MODULE_PATHNAME', $function$command_bson_aggregation_pipeline$function$;
DROP FUNCTION IF EXISTS documentdb_api_catalog.bson_aggregation_distinct;
-- This function is the Mongo distinct query function.
-- It is a wrapper function that passes the aggregation pipeline from the GW to the backend
-- such that the planner phase can replace the parameterized value in the planning phase.
CREATE OR REPLACE FUNCTION documentdb_api_catalog.bson_aggregation_distinct(
    databaseName text,
    distinctSpec documentdb_core.bson,
    OUT document documentdb_core.bson)
 RETURNS SETOF documentdb_core.bson
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
 SUPPORT documentdb_api_internal.aggregation_support
AS 'MODULE_PATHNAME', $function$command_bson_aggregation_pipeline$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_sum_avg_minvtransition(bytea, documentdb_core.bson)
 RETURNS bytea
 LANGUAGE c
 STABLE
AS 'MODULE_PATHNAME', $function$bson_sum_avg_minvtransition$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_array_agg_minvtransition(bytea, documentdb_core.bson, text, boolean)
 RETURNS bytea
 LANGUAGE c
 STABLE
AS 'MODULE_PATHNAME', $function$bson_array_agg_minvtransition$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_covariance_pop_samp_transition(bytea, documentdb_core.bson, documentdb_core.bson)
 RETURNS bytea
 LANGUAGE c
 STABLE
AS 'MODULE_PATHNAME', $function$bson_covariance_pop_samp_transition$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_covariance_pop_samp_combine(bytea, bytea)
 RETURNS bytea
 LANGUAGE c
 STABLE
AS 'MODULE_PATHNAME', $function$bson_covariance_pop_samp_combine$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_covariance_pop_samp_invtransition(bytea, documentdb_core.bson, documentdb_core.bson)
 RETURNS bytea
 LANGUAGE c
 STABLE
AS 'MODULE_PATHNAME', $function$bson_covariance_pop_samp_invtransition$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_covariance_pop_final(bytea)
 RETURNS documentdb_core.bson
 LANGUAGE c
 STABLE
AS 'MODULE_PATHNAME', $function$bson_covariance_pop_final$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_covariance_samp_final(bytea)
 RETURNS documentdb_core.bson
 LANGUAGE c
 STABLE
AS 'MODULE_PATHNAME', $function$bson_covariance_samp_final$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_rank()
 RETURNS documentdb_core.bson
 LANGUAGE c
 STABLE
 WINDOW
AS 'MODULE_PATHNAME', $function$bson_rank$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_dense_rank()
 RETURNS documentdb_core.bson
 LANGUAGE c
 STABLE
 WINDOW
AS 'MODULE_PATHNAME', $function$bson_dense_rank$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_exp_moving_avg(documentdb_core.bson, documentdb_core.bson, boolean)
 RETURNS documentdb_core.bson
 LANGUAGE c
 STABLE
 WINDOW
AS 'MODULE_PATHNAME', $function$bson_exp_moving_avg$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_linear_fill(documentdb_core.bson, documentdb_core.bson)
 RETURNS documentdb_core.bson
 LANGUAGE c
 STABLE
 WINDOW
AS 'MODULE_PATHNAME', $function$bson_linear_fill$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_locf_fill(documentdb_core.bson)
 RETURNS documentdb_core.bson
 LANGUAGE c
 STABLE
 WINDOW
AS 'MODULE_PATHNAME', $function$bson_locf_fill$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_document_number()
 RETURNS documentdb_core.bson
 LANGUAGE c
 STABLE
 WINDOW
AS 'MODULE_PATHNAME', $function$bson_document_number$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_shift(documentdb_core.bson, integer, documentdb_core.bson)
 RETURNS documentdb_core.bson
 LANGUAGE c
 STABLE
 WINDOW
AS 'MODULE_PATHNAME', $function$bson_shift$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_derivative_transition(bytea, documentdb_core.bson, documentdb_core.bson, bigint)
 RETURNS bytea
 LANGUAGE c
 STABLE
AS 'MODULE_PATHNAME', $function$bson_derivative_transition$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_integral_transition(bytea, documentdb_core.bson, documentdb_core.bson, bigint)
 RETURNS bytea
 LANGUAGE c
 STABLE
AS 'MODULE_PATHNAME', $function$bson_integral_transition$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_integral_derivative_final(bytea)
 RETURNS documentdb_core.bson
 LANGUAGE c
 STABLE
AS 'MODULE_PATHNAME', $function$bson_integral_derivative_final$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_std_dev_pop_samp_winfunc_invtransition(bytea, documentdb_core.bson)
 RETURNS bytea
 LANGUAGE c
 STABLE
AS 'MODULE_PATHNAME', $function$bson_std_dev_pop_samp_winfunc_invtransition$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_std_dev_pop_winfunc_final(bytea)
 RETURNS documentdb_core.bson
 LANGUAGE c
 STABLE
AS 'MODULE_PATHNAME', $function$bson_std_dev_pop_winfunc_final$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_std_dev_samp_winfunc_final(bytea)
 RETURNS documentdb_core.bson
 LANGUAGE c
 STABLE
AS 'MODULE_PATHNAME', $function$bson_std_dev_samp_winfunc_final$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_const_fill(documentdb_core.bson, documentdb_core.bson)
 RETURNS documentdb_core.bson
 LANGUAGE c
 STABLE
 WINDOW
AS 'MODULE_PATHNAME', $function$bson_const_fill$function$;
CREATE OR REPLACE AGGREGATE documentdb_api_internal.BSONCOVARIANCEPOP(documentdb_core.bson, documentdb_core.bson)
(
    SFUNC = documentdb_api_internal.bson_covariance_pop_samp_transition,
    FINALFUNC = documentdb_api_internal.bson_covariance_pop_final,
    MSFUNC = documentdb_api_internal.bson_covariance_pop_samp_transition,
    MFINALFUNC = documentdb_api_internal.bson_covariance_pop_final,
    MINVFUNC = documentdb_api_internal.bson_covariance_pop_samp_invtransition,
    stype = bytea,
    mstype = bytea,
    COMBINEFUNC = documentdb_api_internal.bson_covariance_pop_samp_combine,
    PARALLEL = SAFE
);
CREATE OR REPLACE AGGREGATE documentdb_api_internal.BSONCOVARIANCESAMP(documentdb_core.bson, documentdb_core.bson)
(
    SFUNC = documentdb_api_internal.bson_covariance_pop_samp_transition,
    FINALFUNC = documentdb_api_internal.bson_covariance_samp_final,
    MSFUNC = documentdb_api_internal.bson_covariance_pop_samp_transition,
    MFINALFUNC = documentdb_api_internal.bson_covariance_samp_final,
    MINVFUNC = documentdb_api_internal.bson_covariance_pop_samp_invtransition,
    stype = bytea,
    mstype = bytea,
    COMBINEFUNC = documentdb_api_internal.bson_covariance_pop_samp_combine,
    PARALLEL = SAFE
);
CREATE OR REPLACE AGGREGATE documentdb_api_internal.BSONDERIVATIVE(documentdb_core.bson, documentdb_core.bson, bigint)
(
    SFUNC = documentdb_api_internal.bson_derivative_transition,
    FINALFUNC = documentdb_api_internal.bson_integral_derivative_final,
    stype = bytea,
    PARALLEL = SAFE
);
CREATE OR REPLACE AGGREGATE documentdb_api_internal.BSONINTEGRAL(documentdb_core.bson, documentdb_core.bson, bigint)
(
    SFUNC = documentdb_api_internal.bson_integral_transition,
    FINALFUNC = documentdb_api_internal.bson_integral_derivative_final,
    stype = bytea,
    PARALLEL = SAFE
);
CREATE OR REPLACE FUNCTION documentdb_api_catalog.bson_sum_avg_transition(bytea, documentdb_core.bson)
 RETURNS bytea
 LANGUAGE c
 STABLE
AS 'MODULE_PATHNAME', $function$bson_sum_avg_transition$function$;
CREATE OR REPLACE FUNCTION documentdb_api_catalog.bson_sum_avg_combine(bytea, bytea)
 RETURNS bytea
 LANGUAGE c
 STABLE
AS 'MODULE_PATHNAME', $function$bson_sum_avg_combine$function$;
CREATE OR REPLACE FUNCTION documentdb_api_catalog.bson_sum_final(bytea)
 RETURNS documentdb_core.bson
 LANGUAGE c
 STABLE
AS 'MODULE_PATHNAME', $function$bson_sum_final$function$;
CREATE OR REPLACE FUNCTION documentdb_api_catalog.bson_avg_final(bytea)
 RETURNS documentdb_core.bson
 LANGUAGE c
 STABLE
AS 'MODULE_PATHNAME', $function$bson_avg_final$function$;
CREATE OR REPLACE FUNCTION documentdb_api_catalog.bson_min_max_final(documentdb_core.bson)
 RETURNS documentdb_core.bson
 LANGUAGE c
 STABLE
AS 'MODULE_PATHNAME', $function$bson_min_max_final$function$;
CREATE OR REPLACE FUNCTION documentdb_api_catalog.bson_max_transition(documentdb_core.bson, documentdb_core.bson)
 RETURNS documentdb_core.bson
 LANGUAGE c
 STABLE
AS 'MODULE_PATHNAME', $function$bson_max_transition$function$;
CREATE OR REPLACE FUNCTION documentdb_api_catalog.bson_min_transition(documentdb_core.bson, documentdb_core.bson)
 RETURNS documentdb_core.bson
 LANGUAGE c
 STABLE
AS 'MODULE_PATHNAME', $function$bson_min_transition$function$;
CREATE OR REPLACE FUNCTION documentdb_api_catalog.bson_min_combine(documentdb_core.bson, documentdb_core.bson)
 RETURNS documentdb_core.bson
 LANGUAGE c
 STABLE
AS 'MODULE_PATHNAME', $function$bson_min_combine$function$;
CREATE OR REPLACE FUNCTION documentdb_api_catalog.bson_max_combine(documentdb_core.bson, documentdb_core.bson)
 RETURNS documentdb_core.bson
 LANGUAGE c
 STABLE
AS 'MODULE_PATHNAME', $function$bson_max_combine$function$;
CREATE OR REPLACE FUNCTION documentdb_api_catalog.bson_first_transition(bytea, documentdb_core.bson, documentdb_core.bson[])
 RETURNS bytea
 LANGUAGE c
 STABLE
AS 'MODULE_PATHNAME', $function$bson_first_transition$function$;
CREATE OR REPLACE FUNCTION documentdb_api_catalog.bson_last_transition(bytea, documentdb_core.bson, documentdb_core.bson[])
 RETURNS bytea
 LANGUAGE c
 STABLE
AS 'MODULE_PATHNAME', $function$bson_last_transition$function$;
CREATE OR REPLACE FUNCTION documentdb_api_catalog.bson_first_transition_on_sorted(bytea, documentdb_core.bson)
 RETURNS bytea
 LANGUAGE c
 STABLE
AS 'MODULE_PATHNAME', $function$bson_first_transition_on_sorted$function$;
CREATE OR REPLACE FUNCTION documentdb_api_catalog.bson_last_transition_on_sorted(bytea, documentdb_core.bson)
 RETURNS bytea
 LANGUAGE c
 STABLE
AS 'MODULE_PATHNAME', $function$bson_last_transition_on_sorted$function$;
CREATE OR REPLACE FUNCTION documentdb_api_catalog.bson_first_last_final_on_sorted(bytea)
 RETURNS documentdb_core.bson
 LANGUAGE c
 STABLE
AS 'MODULE_PATHNAME', $function$bson_first_last_final_on_sorted$function$;
CREATE OR REPLACE FUNCTION documentdb_api_catalog.bson_first_combine(bytea, bytea)
 RETURNS bytea
 LANGUAGE c
 STABLE STRICT
AS 'MODULE_PATHNAME', $function$bson_first_combine$function$;
CREATE OR REPLACE FUNCTION documentdb_api_catalog.bson_last_combine(bytea, bytea)
 RETURNS bytea
 LANGUAGE c
 STABLE STRICT
AS 'MODULE_PATHNAME', $function$bson_last_combine$function$;
CREATE OR REPLACE FUNCTION documentdb_api_catalog.bson_first_last_final(bytea)
 RETURNS documentdb_core.bson
 LANGUAGE c
 STABLE
AS 'MODULE_PATHNAME', $function$bson_first_last_final$function$;
CREATE OR REPLACE FUNCTION documentdb_api_catalog.bson_array_agg_transition(bytea, documentdb_core.bson, text)
 RETURNS bytea
 LANGUAGE c
 STABLE
AS 'MODULE_PATHNAME', $function$bson_array_agg_transition$function$;
CREATE OR REPLACE FUNCTION documentdb_api_catalog.bson_array_agg_transition(bytea, documentdb_core.bson, text, boolean)
 RETURNS bytea
 LANGUAGE c
 STABLE
AS 'MODULE_PATHNAME', $function$bson_array_agg_transition$function$;
CREATE OR REPLACE FUNCTION documentdb_api_catalog.bson_array_agg_final(bytea)
 RETURNS documentdb_core.bson
 LANGUAGE c
 STABLE
AS 'MODULE_PATHNAME', $function$bson_array_agg_final$function$;
CREATE OR REPLACE FUNCTION documentdb_api_catalog.bson_object_agg_transition(bytea, documentdb_core.bson)
 RETURNS bytea
 LANGUAGE c
 STABLE
AS 'MODULE_PATHNAME', $function$bson_object_agg_transition$function$;
CREATE OR REPLACE FUNCTION documentdb_api_catalog.bson_object_agg_final(bytea)
 RETURNS documentdb_core.bson
 LANGUAGE c
 STABLE
AS 'MODULE_PATHNAME', $function$bson_object_agg_final$function$;
CREATE OR REPLACE FUNCTION documentdb_api_catalog.bson_out_transition(bytea, documentdb_core.bson, text, text, text, text)
 RETURNS bytea
 LANGUAGE c
 VOLATILE
AS 'MODULE_PATHNAME', $function$bson_out_transition$function$;
CREATE OR REPLACE FUNCTION documentdb_api_catalog.bson_out_final(bytea)
 RETURNS documentdb_core.bson
 LANGUAGE c
 VOLATILE
AS 'MODULE_PATHNAME', $function$bson_out_final$function$;
CREATE OR REPLACE FUNCTION documentdb_api_catalog.bson_firstn_transition(bytea, documentdb_core.bson, bigint, documentdb_core.bson[])
 RETURNS bytea
 LANGUAGE c
 STABLE
AS 'MODULE_PATHNAME', $function$bson_firstn_transition$function$;
CREATE OR REPLACE FUNCTION documentdb_api_catalog.bson_lastn_transition(bytea, documentdb_core.bson, bigint, documentdb_core.bson[])
 RETURNS bytea
 LANGUAGE c
 STABLE
AS 'MODULE_PATHNAME', $function$bson_lastn_transition$function$;
CREATE OR REPLACE FUNCTION documentdb_api_catalog.bson_firstn_combine(bytea, bytea)
 RETURNS bytea
 LANGUAGE c
 STABLE
AS 'MODULE_PATHNAME', $function$bson_firstn_combine$function$;
CREATE OR REPLACE FUNCTION documentdb_api_catalog.bson_lastn_combine(bytea, bytea)
 RETURNS bytea
 LANGUAGE c
 STABLE
AS 'MODULE_PATHNAME', $function$bson_lastn_combine$function$;
CREATE OR REPLACE FUNCTION documentdb_api_catalog.bson_firstn_lastn_final(bytea)
 RETURNS documentdb_core.bson
 LANGUAGE c
 STABLE
AS 'MODULE_PATHNAME', $function$bson_firstn_lastn_final$function$;
CREATE OR REPLACE FUNCTION documentdb_api_catalog.bson_firstn_transition_on_sorted(bytea, documentdb_core.bson, bigint)
 RETURNS bytea
 LANGUAGE c
 STABLE
AS 'MODULE_PATHNAME', $function$bson_firstn_transition_on_sorted$function$;
CREATE OR REPLACE FUNCTION documentdb_api_catalog.bson_lastn_transition_on_sorted(bytea, documentdb_core.bson, bigint)
 RETURNS bytea
 LANGUAGE c
 STABLE
AS 'MODULE_PATHNAME', $function$bson_lastn_transition_on_sorted$function$;
CREATE OR REPLACE FUNCTION documentdb_api_catalog.bson_firstn_lastn_final_on_sorted(bytea)
 RETURNS documentdb_core.bson
 LANGUAGE c
 STABLE
AS 'MODULE_PATHNAME', $function$bson_firstn_lastn_final_on_sorted$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_add_to_set_transition(bytea, documentdb_core.bson)
 RETURNS bytea
 LANGUAGE c
 STABLE
AS 'MODULE_PATHNAME', $function$bson_add_to_set_transition$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_add_to_set_final(bytea)
 RETURNS documentdb_core.bson
 LANGUAGE c
 STABLE
AS 'MODULE_PATHNAME', $function$bson_add_to_set_final$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_merge_objects_transition_on_sorted(bytea, documentdb_core.bson)
 RETURNS bytea
 LANGUAGE c
 STABLE
AS 'MODULE_PATHNAME', $function$bson_merge_objects_transition_on_sorted$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_merge_objects_transition(bytea, documentdb_core.bson, bigint, documentdb_core.bson[], documentdb_core.bson)
 RETURNS bytea
 LANGUAGE c
 STABLE
AS 'MODULE_PATHNAME', $function$bson_merge_objects_transition$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_merge_objects_final(bytea)
 RETURNS documentdb_core.bson
 LANGUAGE c
 STABLE
AS 'MODULE_PATHNAME', $function$bson_merge_objects_final$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_std_dev_pop_samp_transition(bytea, documentdb_core.bson)
 RETURNS bytea
 LANGUAGE c
 STABLE
AS 'MODULE_PATHNAME', $function$bson_std_dev_pop_samp_transition$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_std_dev_pop_samp_combine(bytea, bytea)
 RETURNS bytea
 LANGUAGE c
 STABLE
AS 'MODULE_PATHNAME', $function$bson_std_dev_pop_samp_combine$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_std_dev_pop_final(bytea)
 RETURNS documentdb_core.bson
 LANGUAGE c
 STABLE
AS 'MODULE_PATHNAME', $function$bson_std_dev_pop_final$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_std_dev_samp_final(bytea)
 RETURNS documentdb_core.bson
 LANGUAGE c
 STABLE
AS 'MODULE_PATHNAME', $function$bson_std_dev_samp_final$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_first_transition(bytea, documentdb_core.bson, documentdb_core.bson[], documentdb_core.bson DEFAULT NULL)
 RETURNS bytea
 LANGUAGE c
 STABLE
AS 'MODULE_PATHNAME', $function$bson_first_transition$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_last_transition(bytea, documentdb_core.bson, documentdb_core.bson[], documentdb_core.bson DEFAULT NULL)
 RETURNS bytea
 LANGUAGE c
 STABLE
AS 'MODULE_PATHNAME', $function$bson_last_transition$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_firstn_transition(bytea, documentdb_core.bson, bigint, documentdb_core.bson[], documentdb_core.bson DEFAULT NULL)
 RETURNS bytea
 LANGUAGE c
 STABLE
AS 'MODULE_PATHNAME', $function$bson_firstn_transition$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_lastn_transition(bytea, documentdb_core.bson, bigint, documentdb_core.bson[], documentdb_core.bson DEFAULT NULL)
 RETURNS bytea
 LANGUAGE c
 STABLE
AS 'MODULE_PATHNAME', $function$bson_lastn_transition$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_maxn_transition(bytea, documentdb_core.bson)
 RETURNS bytea
 LANGUAGE c
 STABLE
AS 'MODULE_PATHNAME', $function$bson_maxn_transition$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_minn_transition(bytea, documentdb_core.bson)
 RETURNS bytea
 LANGUAGE c
 STABLE
AS 'MODULE_PATHNAME', $function$bson_minn_transition$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_maxminn_final(bytea)
 RETURNS documentdb_core.bson
 LANGUAGE c
 STABLE
AS 'MODULE_PATHNAME', $function$bson_maxminn_final$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_maxminn_combine(bytea, bytea)
 RETURNS bytea
 LANGUAGE c
 STABLE
AS 'MODULE_PATHNAME', $function$bson_maxminn_combine$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_first_transition_on_sorted(bytea, documentdb_core.bson, documentdb_core.bson DEFAULT NULL)
 RETURNS bytea
 LANGUAGE c
 STABLE
AS 'MODULE_PATHNAME', $function$bson_first_transition_on_sorted$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_last_transition_on_sorted(bytea, documentdb_core.bson, documentdb_core.bson DEFAULT NULL)
 RETURNS bytea
 LANGUAGE c
 STABLE
AS 'MODULE_PATHNAME', $function$bson_last_transition_on_sorted$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_firstn_transition_on_sorted(bytea, documentdb_core.bson, bigint, documentdb_core.bson DEFAULT NULL)
 RETURNS bytea
 LANGUAGE c
 STABLE
AS 'MODULE_PATHNAME', $function$bson_firstn_transition_on_sorted$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_lastn_transition_on_sorted(bytea, documentdb_core.bson, bigint, documentdb_core.bson DEFAULT NULL)
 RETURNS bytea
 LANGUAGE c
 STABLE
AS 'MODULE_PATHNAME', $function$bson_lastn_transition_on_sorted$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.tdigest_add_double(internal, documentdb_core.bson, int4, documentdb_core.bson)
 RETURNS internal
 LANGUAGE c
 IMMUTABLE
AS 'MODULE_PATHNAME', $function$tdigest_add_double$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.tdigest_add_double_array(internal, documentdb_core.bson, int4, documentdb_core.bson)
 RETURNS internal
 LANGUAGE c
 IMMUTABLE
AS 'MODULE_PATHNAME', $function$tdigest_add_double_array$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.tdigest_percentile(internal)
 RETURNS documentdb_core.bson
 LANGUAGE c
 IMMUTABLE
AS 'MODULE_PATHNAME', $function$tdigest_percentile$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.tdigest_array_percentiles(internal)
 RETURNS documentdb_core.bson
 LANGUAGE c
 IMMUTABLE
AS 'MODULE_PATHNAME', $function$tdigest_array_percentiles$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.tdigest_combine(internal, internal)
 RETURNS internal
 LANGUAGE c
 IMMUTABLE
AS 'MODULE_PATHNAME', $function$tdigest_combine$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.tdigest_serial(internal)
 RETURNS bytea
 LANGUAGE c
 IMMUTABLE STRICT
AS 'MODULE_PATHNAME', $function$tdigest_serial$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.tdigest_deserial(bytea, internal)
 RETURNS internal
 LANGUAGE c
 IMMUTABLE STRICT
AS 'MODULE_PATHNAME', $function$tdigest_deserial$function$;
CREATE OR REPLACE AGGREGATE documentdb_api_catalog.BSONSUM(documentdb_core.bson)
(
    SFUNC = documentdb_api_catalog.bson_sum_avg_transition,
    FINALFUNC = documentdb_api_catalog.bson_sum_final,
    stype = bytea,
    COMBINEFUNC = documentdb_api_catalog.bson_sum_avg_combine,
    mstype = bytea,
    MSFUNC = documentdb_api_catalog.bson_sum_avg_transition,
    MFINALFUNC = documentdb_api_catalog.bson_sum_final,
    MINVFUNC = documentdb_api_internal.bson_sum_avg_minvtransition,
    PARALLEL = SAFE
);
CREATE OR REPLACE AGGREGATE documentdb_api_catalog.BSONAVERAGE(documentdb_core.bson)
(
    SFUNC = documentdb_api_catalog.bson_sum_avg_transition,
    FINALFUNC = documentdb_api_catalog.bson_avg_final,
    stype = bytea,
    COMBINEFUNC = documentdb_api_catalog.bson_sum_avg_combine,
    mstype = bytea,
    MSFUNC = documentdb_api_catalog.bson_sum_avg_transition,
    MFINALFUNC = documentdb_api_catalog.bson_avg_final,
    MINVFUNC = documentdb_api_internal.bson_sum_avg_minvtransition,
    PARALLEL = SAFE
);
CREATE OR REPLACE AGGREGATE documentdb_api_catalog.BSONMAX(documentdb_core.bson)
(
    SFUNC = documentdb_api_catalog.bson_max_transition,
    FINALFUNC = documentdb_api_catalog.bson_min_max_final,
    stype = documentdb_core.bson,
    COMBINEFUNC = documentdb_api_catalog.bson_max_combine,
    PARALLEL = SAFE
);
CREATE OR REPLACE AGGREGATE documentdb_api_catalog.BSONMIN(documentdb_core.bson)
(
    SFUNC = documentdb_api_catalog.bson_min_transition,
    FINALFUNC = documentdb_api_catalog.bson_min_max_final,
    stype = documentdb_core.bson,
    COMBINEFUNC = documentdb_api_catalog.bson_min_combine,
    PARALLEL = SAFE
);
CREATE OR REPLACE AGGREGATE documentdb_api_catalog.BSONFIRST(documentdb_core.bson, documentdb_core.bson[])
(
    SFUNC = documentdb_api_catalog.bson_first_transition,
    FINALFUNC = documentdb_api_catalog.bson_first_last_final,
    stype = bytea,
    COMBINEFUNC = documentdb_api_catalog.bson_first_combine,
    PARALLEL = SAFE
);
CREATE OR REPLACE AGGREGATE documentdb_api_catalog.BSONLAST(documentdb_core.bson, documentdb_core.bson[])
(
    SFUNC = documentdb_api_catalog.bson_last_transition,
    FINALFUNC = documentdb_api_catalog.bson_first_last_final,
    stype = bytea,
    COMBINEFUNC = documentdb_api_catalog.bson_last_combine,
    PARALLEL = SAFE
);
CREATE OR REPLACE AGGREGATE documentdb_api_catalog.BSONFIRSTONSORTED(documentdb_core.bson)
(
    SFUNC = documentdb_api_catalog.bson_first_transition_on_sorted,
    FINALFUNC = documentdb_api_catalog.bson_first_last_final_on_sorted,
    stype = bytea,
    PARALLEL = SAFE
);
CREATE OR REPLACE AGGREGATE documentdb_api_catalog.BSONLASTONSORTED(documentdb_core.bson)
(
    SFUNC = documentdb_api_catalog.bson_last_transition_on_sorted,
    FINALFUNC = documentdb_api_catalog.bson_first_last_final_on_sorted,
    stype = bytea,
    PARALLEL = SAFE
);
CREATE OR REPLACE AGGREGATE documentdb_api_catalog.BSONFIRSTN(documentdb_core.bson, bigint, documentdb_core.bson[])
(
    SFUNC = documentdb_api_catalog.bson_firstn_transition,
    FINALFUNC = documentdb_api_catalog.bson_firstn_lastn_final,
    stype = bytea,
    COMBINEFUNC = documentdb_api_catalog.bson_firstn_combine,
    PARALLEL = SAFE
);
CREATE OR REPLACE AGGREGATE documentdb_api_catalog.BSONLASTN(documentdb_core.bson, bigint, documentdb_core.bson[])
(
    SFUNC = documentdb_api_catalog.bson_lastn_transition,
    FINALFUNC = documentdb_api_catalog.bson_firstn_lastn_final,
    stype = bytea,
    COMBINEFUNC = documentdb_api_catalog.bson_lastn_combine,
    PARALLEL = SAFE
);
CREATE OR REPLACE AGGREGATE documentdb_api_catalog.BSONFIRSTNONSORTED(documentdb_core.bson, bigint)
(
    SFUNC = documentdb_api_catalog.bson_firstn_transition_on_sorted,
    FINALFUNC = documentdb_api_catalog.bson_firstn_lastn_final_on_sorted,
    stype = bytea,
    PARALLEL = SAFE
);
CREATE OR REPLACE AGGREGATE documentdb_api_catalog.BSONLASTNONSORTED(documentdb_core.bson, bigint)
(
    SFUNC = documentdb_api_catalog.bson_lastn_transition_on_sorted,
    FINALFUNC = documentdb_api_catalog.bson_firstn_lastn_final_on_sorted,
    stype = bytea,
    PARALLEL = SAFE
);
CREATE OR REPLACE AGGREGATE documentdb_api_catalog.BSON_ARRAY_AGG(documentdb_core.bson, text)
(
    SFUNC = documentdb_api_catalog.bson_array_agg_transition,
    FINALFUNC = documentdb_api_catalog.bson_array_agg_final,
    stype = bytea,
    PARALLEL = SAFE
);
CREATE OR REPLACE AGGREGATE documentdb_api_catalog.BSON_OBJECT_AGG(documentdb_core.bson)
(
    SFUNC = documentdb_api_catalog.bson_object_agg_transition,
    FINALFUNC = documentdb_api_catalog.bson_object_agg_final,
    stype = bytea,
    PARALLEL = SAFE
);
CREATE OR REPLACE AGGREGATE documentdb_api_catalog.BSON_OUT(documentdb_core.bson, text, text, text, text)
(
    SFUNC = documentdb_api_catalog.bson_out_transition,
    FINALFUNC = documentdb_api_catalog.bson_out_final,
    stype = bytea
);
CREATE OR REPLACE AGGREGATE documentdb_api_catalog.BSON_ARRAY_AGG(documentdb_core.bson, text, boolean)
(
    SFUNC = documentdb_api_catalog.bson_array_agg_transition,
    FINALFUNC = documentdb_api_catalog.bson_array_agg_final,
    stype = bytea,
    mstype = bytea,
    MSFUNC = documentdb_api_catalog.bson_array_agg_transition,
    MFINALFUNC = documentdb_api_catalog.bson_array_agg_final,
    MINVFUNC = documentdb_api_internal.bson_array_agg_minvtransition,
    PARALLEL = SAFE
);
CREATE OR REPLACE AGGREGATE documentdb_api_internal.BSON_ADD_TO_SET(documentdb_core.bson)
(
    SFUNC = documentdb_api_internal.bson_add_to_set_transition,
    FINALFUNC = documentdb_api_internal.bson_add_to_set_final,
    stype = bytea,
    PARALLEL = SAFE
);
CREATE OR REPLACE AGGREGATE documentdb_api_internal.BSON_MERGE_OBJECTS_ON_SORTED(documentdb_core.bson)
(
    SFUNC = documentdb_api_internal.bson_merge_objects_transition_on_sorted,
    FINALFUNC = documentdb_api_catalog.bson_object_agg_final,
    stype = bytea,
    PARALLEL = SAFE
);
CREATE OR REPLACE AGGREGATE documentdb_api_internal.BSON_MERGE_OBJECTS(documentdb_core.bson, bigint, documentdb_core.bson[], documentdb_core.bson)
(
    SFUNC = documentdb_api_internal.bson_merge_objects_transition,
    FINALFUNC = documentdb_api_internal.bson_merge_objects_final,
    stype = bytea,
    COMBINEFUNC = documentdb_api_catalog.bson_firstn_combine,
    PARALLEL = SAFE
);
CREATE OR REPLACE AGGREGATE documentdb_api_internal.BSONSTDDEVPOP(documentdb_core.bson)
(
    SFUNC = documentdb_api_internal.bson_std_dev_pop_samp_transition,
    FINALFUNC = documentdb_api_internal.bson_std_dev_pop_final,
    MSFUNC = documentdb_api_internal.bson_std_dev_pop_samp_transition,
    MFINALFUNC = documentdb_api_internal.bson_std_dev_pop_winfunc_final,
    MINVFUNC = documentdb_api_internal.bson_std_dev_pop_samp_winfunc_invtransition,
    stype = bytea,
    mstype = bytea,
    COMBINEFUNC = documentdb_api_internal.bson_std_dev_pop_samp_combine,
    PARALLEL = SAFE
);
CREATE OR REPLACE AGGREGATE documentdb_api_internal.BSONSTDDEVSAMP(documentdb_core.bson)
(
    SFUNC = documentdb_api_internal.bson_std_dev_pop_samp_transition,
    FINALFUNC = documentdb_api_internal.bson_std_dev_samp_final,
    MSFUNC = documentdb_api_internal.bson_std_dev_pop_samp_transition,
    MFINALFUNC = documentdb_api_internal.bson_std_dev_samp_winfunc_final,
    MINVFUNC = documentdb_api_internal.bson_std_dev_pop_samp_winfunc_invtransition,
    stype = bytea,
    mstype = bytea,
    COMBINEFUNC = documentdb_api_internal.bson_std_dev_pop_samp_combine,
    PARALLEL = SAFE
);
CREATE OR REPLACE AGGREGATE documentdb_api_internal.BSONFIRST(documentdb_core.bson, documentdb_core.bson[], documentdb_core.bson)
(
    SFUNC = documentdb_api_internal.bson_first_transition,
    FINALFUNC = documentdb_api_catalog.bson_first_last_final,
    stype = bytea,
    COMBINEFUNC = documentdb_api_catalog.bson_first_combine,
    PARALLEL = SAFE
);
CREATE OR REPLACE AGGREGATE documentdb_api_internal.BSONLAST(documentdb_core.bson, documentdb_core.bson[], documentdb_core.bson)
(
    SFUNC = documentdb_api_internal.bson_last_transition,
    FINALFUNC = documentdb_api_catalog.bson_first_last_final,
    stype = bytea,
    COMBINEFUNC = documentdb_api_catalog.bson_last_combine,
    PARALLEL = SAFE
);
CREATE OR REPLACE AGGREGATE documentdb_api_internal.BSONFIRSTN(documentdb_core.bson, bigint, documentdb_core.bson[], documentdb_core.bson)
(
    SFUNC = documentdb_api_internal.bson_firstn_transition,
    FINALFUNC = documentdb_api_catalog.bson_firstn_lastn_final,
    stype = bytea,
    COMBINEFUNC = documentdb_api_catalog.bson_firstn_combine,
    PARALLEL = SAFE
);
CREATE OR REPLACE AGGREGATE documentdb_api_internal.BSONLASTN(documentdb_core.bson, bigint, documentdb_core.bson[], documentdb_core.bson)
(
    SFUNC = documentdb_api_internal.bson_lastn_transition,
    FINALFUNC = documentdb_api_catalog.bson_firstn_lastn_final,
    stype = bytea,
    COMBINEFUNC = documentdb_api_catalog.bson_lastn_combine,
    PARALLEL = SAFE
);
CREATE OR REPLACE AGGREGATE documentdb_api_internal.BSONMAXN(documentdb_core.bson)
(
    SFUNC = documentdb_api_internal.bson_maxn_transition,
    FINALFUNC = documentdb_api_internal.bson_maxminn_final,
    stype = bytea,
    COMBINEFUNC = documentdb_api_internal.bson_maxminn_combine,
    PARALLEL = SAFE
);
CREATE OR REPLACE AGGREGATE documentdb_api_internal.BSONMINN(documentdb_core.bson)
(
    SFUNC = documentdb_api_internal.bson_minn_transition,
    FINALFUNC = documentdb_api_internal.bson_maxminn_final,
    stype = bytea,
    COMBINEFUNC = documentdb_api_internal.bson_maxminn_combine,
    PARALLEL = SAFE
);
CREATE OR REPLACE AGGREGATE documentdb_api_internal.BSONFIRSTONSORTED(documentdb_core.bson, documentdb_core.bson)
(
    SFUNC = documentdb_api_internal.bson_first_transition_on_sorted,
    FINALFUNC = documentdb_api_catalog.bson_first_last_final_on_sorted,
    stype = bytea,
    PARALLEL = SAFE
);
CREATE OR REPLACE AGGREGATE documentdb_api_internal.BSONLASTONSORTED(documentdb_core.bson, documentdb_core.bson)
(
    SFUNC = documentdb_api_internal.bson_last_transition_on_sorted,
    FINALFUNC = documentdb_api_catalog.bson_first_last_final_on_sorted,
    stype = bytea,
    PARALLEL = SAFE
);
CREATE OR REPLACE AGGREGATE documentdb_api_internal.BSONFIRSTNONSORTED(documentdb_core.bson, bigint, documentdb_core.bson)
(
    SFUNC = documentdb_api_internal.bson_firstn_transition_on_sorted,
    FINALFUNC = documentdb_api_catalog.bson_firstn_lastn_final_on_sorted,
    stype = bytea,
    PARALLEL = SAFE
);
CREATE OR REPLACE AGGREGATE documentdb_api_internal.BSONLASTNONSORTED(documentdb_core.bson, bigint, documentdb_core.bson)
(
    SFUNC = documentdb_api_internal.bson_lastn_transition_on_sorted,
    FINALFUNC = documentdb_api_catalog.bson_firstn_lastn_final_on_sorted,
    stype = bytea,
    PARALLEL = SAFE
);
CREATE OR REPLACE AGGREGATE documentdb_api_internal.BSONPERCENTILE(documentdb_core.bson, int4, documentdb_core.bson)
(
    SFUNC = documentdb_api_internal.tdigest_add_double_array,
    stype = internal,
    FINALFUNC = documentdb_api_internal.tdigest_array_percentiles,
    SERIALFUNC = documentdb_api_internal.tdigest_serial,
    DESERIALFUNC = documentdb_api_internal.tdigest_deserial,
    COMBINEFUNC = documentdb_api_internal.tdigest_combine,
    PARALLEL = SAFE
);
CREATE OR REPLACE AGGREGATE documentdb_api_internal.BSONMEDIAN(documentdb_core.bson, int4, documentdb_core.bson)
(
    SFUNC = documentdb_api_internal.tdigest_add_double,
    stype = internal,
    FINALFUNC = documentdb_api_internal.tdigest_percentile,
    SERIALFUNC = documentdb_api_internal.tdigest_serial,
    DESERIALFUNC = documentdb_api_internal.tdigest_deserial,
    COMBINEFUNC = documentdb_api_internal.tdigest_combine,
    PARALLEL = SAFE
);
CREATE OR REPLACE FUNCTION documentdb_api_catalog.bson_dollar_unwind(documentdb_core.bson, text)
 RETURNS SETOF documentdb_core.bson
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT ROWS 100
AS 'MODULE_PATHNAME', $function$bson_dollar_unwind$function$;
CREATE OR REPLACE FUNCTION documentdb_api_catalog.bson_dollar_unwind(documentdb_core.bson, documentdb_core.bson)
 RETURNS SETOF documentdb_core.bson
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT ROWS 100
AS 'MODULE_PATHNAME', $function$bson_dollar_unwind_with_options$function$;
CREATE OR REPLACE FUNCTION documentdb_api_catalog.bson_distinct_unwind(documentdb_core.bson, text)
 RETURNS SETOF documentdb_core.bson
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT ROWS 100
AS 'MODULE_PATHNAME', $function$bson_distinct_unwind$function$;
CREATE OR REPLACE FUNCTION documentdb_api_catalog.bson_build_distinct_response(documentdb_core.bson[])
 RETURNS documentdb_core.bson
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE
AS 'MODULE_PATHNAME', $function$bson_build_distinct_response$function$;
DROP FUNCTION IF EXISTS documentdb_api_catalog.bson_dollar_lookup_extract_filter_expression;
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_dollar_lookup_extract_filter_expression(documentdb_core.bson, documentdb_core.bson)
 RETURNS documentdb_core.bson
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$bson_dollar_lookup_extract_filter_expression$function$;
CREATE OR REPLACE FUNCTION documentdb_api_catalog.bson_lookup_unwind(documentdb_core.bson, text)
 RETURNS SETOF documentdb_core.bson
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT ROWS 100
AS 'MODULE_PATHNAME', $function$bson_lookup_unwind$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_dollar_lookup_extract_filter_array(documentdb_core.bson, documentdb_core.bson)
 RETURNS documentdb_core.bson[]
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$bson_dollar_lookup_extract_filter_array$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_dollar_lookup_filter_support(internal)
 RETURNS internal
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $$bson_dollar_lookup_filter_support$$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_dollar_lookup_join_filter(documentdb_core.bson, documentdb_core.bson, text)
 RETURNS bool
 LANGUAGE c
 SUPPORT documentdb_api_internal.bson_dollar_lookup_filter_support
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$bson_dollar_lookup_join_filter$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_dollar_lookup_project(documentdb_core.bson, documentdb_core.bson[], text)
 RETURNS SETOF documentdb_core.bson
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT ROWS 100
AS 'MODULE_PATHNAME', $function$bson_dollar_lookup_project$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_distinct_array_agg_transition(bytea, documentdb_core.bson)
 RETURNS bytea
 LANGUAGE c
 STABLE
AS 'MODULE_PATHNAME', $function$bson_distinct_array_agg_transition$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_distinct_array_agg_final(bytea)
 RETURNS documentdb_core.bson
 LANGUAGE c
 STABLE
AS 'MODULE_PATHNAME', $function$bson_distinct_array_agg_final$function$;
CREATE OR REPLACE AGGREGATE documentdb_api_catalog.BSON_DISTINCT_AGG(documentdb_core.bson)
(
    SFUNC = documentdb_api_internal.bson_distinct_array_agg_transition,
    FINALFUNC = documentdb_api_internal.bson_distinct_array_agg_final,
    stype = bytea,
    PARALLEL = SAFE
);
CREATE OR REPLACE FUNCTION documentdb_api_internal.documentdb_core_bson_to_bson(documentdb_core.bson)
 RETURNS documentdb_core.bson
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$documentdb_core_bson_to_bson$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_densify_range(documentdb_core.bson, documentdb_core.bson)
 RETURNS documentdb_core.bson
 LANGUAGE c
 WINDOW
 STABLE
AS 'MODULE_PATHNAME', $function$bson_densify_range$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_densify_partition(documentdb_core.bson, documentdb_core.bson)
 RETURNS documentdb_core.bson
 LANGUAGE c
 WINDOW
 STABLE
AS 'MODULE_PATHNAME', $function$bson_densify_partition$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_densify_full(documentdb_core.bson, documentdb_core.bson)
 RETURNS documentdb_core.bson
 LANGUAGE c
 WINDOW
 STABLE
AS 'MODULE_PATHNAME', $function$bson_densify_full$function$;
-- drop the public schema function and move it to documentdb_api_internal
DROP FUNCTION IF EXISTS documentdb_api_catalog.bson_dollar_inverse_match;
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_dollar_inverse_match(
    document documentdb_core.bson,
    spec documentdb_core.bson)
 RETURNS bool
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$bson_dollar_inverse_match$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_dollar_merge_handle_when_matched(documentdb_core.bson,documentdb_core.bson, int4)
 RETURNS documentdb_core.bson
 LANGUAGE c
 IMMUTABLE STRICT
AS 'MODULE_PATHNAME', $function$bson_dollar_merge_handle_when_matched$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_dollar_merge_filter_support(internal)
 RETURNS internal
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $$bson_dollar_merge_filter_support$$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_dollar_merge_join(documentdb_core.bson,documentdb_core.bson, text)
 RETURNS BOOLEAN
 LANGUAGE c
 SUPPORT documentdb_api_internal.bson_dollar_merge_filter_support
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$bson_dollar_merge_join_filter$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_dollar_merge_add_object_id(documentdb_core.bson, documentdb_core.bson)
 RETURNS documentdb_core.bson
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$bson_dollar_merge_add_object_id$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_dollar_merge_fail_when_not_matched(documentdb_core.bson,text)
 RETURNS documentdb_core.bson
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$bson_dollar_merge_fail_when_not_matched$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_dollar_merge_generate_object_id(documentdb_core.bson)
 RETURNS documentdb_core.bson
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$bson_dollar_merge_generate_object_id$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_dollar_extract_merge_filter(documentdb_core.bson, text)
 RETURNS documentdb_core.bson
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$bson_dollar_extract_merge_filter$function$;
DROP FUNCTION IF EXISTS documentdb_api.empty_data_table;
CREATE OR REPLACE FUNCTION documentdb_api_internal.empty_data_table(
    OUT shard_key_value bigint,
    OUT object_id documentdb_core.bson,
    OUT document documentdb_core.bson,
    OUT creation_time timestamptz)
RETURNS SETOF record
AS $fn$
BEGIN
  RETURN QUERY EXECUTE format($$SELECT 0::bigint, null::documentdb_core.bson, null::documentdb_core.bson, null::timestamptz WHERE false$$);
END;
$fn$ LANGUAGE plpgsql;
COMMENT ON FUNCTION documentdb_api_internal.empty_data_table()
    IS 'mimics a data collection with 0 rows';
CREATE OR REPLACE FUNCTION documentdb_api.collection(
    p_database_name text,
    p_collection_name text,
    OUT shard_key_value bigint,
    OUT object_id documentdb_core.bson,
    OUT document documentdb_core.bson,
    OUT creation_time timestamptz)
RETURNS SETOF record
LANGUAGE c
 STRICT
AS 'MODULE_PATHNAME', $function$command_api_collection$function$;
COMMENT ON FUNCTION documentdb_api.collection(text,text)
    IS 'query a collection';
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_dollar_redact(documentdb_core.bson, documentdb_core.bson, text, documentdb_core.bson)
 RETURNS documentdb_core.bson
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$bson_dollar_redact$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.documentdb_get_next_collection_id()
 RETURNS bigint
 LANGUAGE c
 STRICT
AS 'MODULE_PATHNAME', $function$command_get_next_collection_id$function$;
COMMENT ON FUNCTION documentdb_api_internal.documentdb_get_next_collection_id()
    IS 'get next unique collection id to be used in __API_CATALOG_SCHEMA__.collections';
CREATE OR REPLACE FUNCTION documentdb_api_internal.ensure_valid_db_coll(text, text)
 RETURNS bool
 LANGUAGE c
 STRICT
AS 'MODULE_PATHNAME', $function$command_ensure_valid_db_coll$function$;
CREATE FUNCTION documentdb_api_internal.collection_update_trigger()
 RETURNS trigger
 LANGUAGE plpgsql
AS $function$
BEGIN
 PERFORM documentdb_api_internal.invalidate_collection_cache();
 RETURN NULL;
END;
$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.invalidate_collection_cache()
 RETURNS void
 LANGUAGE c
AS 'MODULE_PATHNAME', $$command_invalidate_collection_cache$$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.trigger_validate_dbname()
 RETURNS trigger
 LANGUAGE plpgsql
AS $function$
BEGIN
 PERFORM documentdb_api_internal.validate_dbname(NEW.database_name);
 RETURN NEW;
END;
$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.validate_dbname(dbname text)
 RETURNS void
 LANGUAGE c
AS 'MODULE_PATHNAME', $$validate_dbname$$;
CREATE SEQUENCE documentdb_api_catalog.collections_collection_id_seq AS bigint;
CREATE TABLE documentdb_api_catalog.collections (
    database_name text not null,
    collection_name text not null,
    collection_id bigint not null unique default documentdb_api_internal.documentdb_get_next_collection_id(),
    shard_key documentdb_core.bson,
    collection_uuid uuid,
    PRIMARY KEY (database_name, collection_name),
    CONSTRAINT valid_db_coll_name CHECK (documentdb_api_internal.ensure_valid_db_coll(database_name, collection_name))
);
CREATE OR REPLACE TRIGGER collections_trigger_validate_dbname
    BEFORE INSERT OR UPDATE ON documentdb_api_catalog.collections
    FOR EACH ROW EXECUTE FUNCTION documentdb_api_internal.trigger_validate_dbname();
CREATE TRIGGER collections_trigger
 AFTER UPDATE OR DELETE ON documentdb_api_catalog.collections
 FOR STATEMENT EXECUTE FUNCTION documentdb_api_internal.collection_update_trigger();
ALTER TABLE documentdb_api_catalog.collections ADD view_definition documentdb_core.bson default null;
ALTER TABLE documentdb_api_catalog.collections
        ADD COLUMN validator documentdb_core.bson DEFAULT null,
        ADD COLUMN validation_level text DEFAULT null CONSTRAINT validation_level_check CHECK (validation_level IN ('off', 'strict', 'moderate')),
        ADD COLUMN validation_action text DEFAULT null CONSTRAINT validation_action_check CHECK (validation_action IN ('warn', 'error'));
CREATE OR REPLACE FUNCTION documentdb_api_internal.documentdb_get_next_collection_index_id()
 RETURNS integer
 LANGUAGE c
 STRICT
AS 'MODULE_PATHNAME', $function$command_get_next_collection_index_id$function$;
COMMENT ON FUNCTION documentdb_api_internal.documentdb_get_next_collection_index_id()
    IS 'get next unique index id to be used in __API_CATALOG_SCHEMA__.collection_indexes';
CREATE TYPE documentdb_api_catalog.index_spec_type_internal AS (
    -- Mongo index name
    index_name text,
    --
    -- index options start here
    --
    -- "key" document used when creating the index
    index_key documentdb_core.bson,
    -- "partialFilterExpression" document used when creating the index
    index_pfe documentdb_core.bson,
    -- Normalized form of "wildcardProjection" document used when creating the index.
    -- "null" if the index doesn't have a "wildcardProjection" specification.
    index_wp documentdb_core.bson,
    -- indicates if the index was created as sparse index or not
    index_is_sparse bool,
    -- indicates if the index was created as a unique index or not.
    index_is_unique bool,
    -- version of the indexing engine used to create this index
    index_version int,
    -- document expiry threshold for ttl index
    index_expire_after_seconds int
);
CREATE DOMAIN documentdb_api_catalog.index_spec_type AS documentdb_api_catalog.index_spec_type_internal
CHECK ((VALUE).index_version IS NOT NULL AND
       (VALUE).index_version > 0 AND
       (VALUE).index_name IS NOT NULL AND
       (VALUE).index_key IS NOT NULL AND
       ((VALUE).index_expire_after_seconds IS NULL OR (VALUE).index_expire_after_seconds >= 0));
CREATE SEQUENCE documentdb_api_catalog.collection_indexes_index_id_seq AS integer START WITH 1; -- let 0 mean invalid, see index.h/INVALID_INDEX_ID
CREATE TABLE documentdb_api_catalog.collection_indexes (
    -- Postgres side collection id that corresponds to
    -- documentdb_api_catalog.collections(database_name, collection_name)
    collection_id bigint not null,
    -- Postgres side index id assigned to this Mongo index
    index_id integer default documentdb_api_internal.documentdb_get_next_collection_index_id(),
    -- Mongo index spec
    index_spec documentdb_api_catalog.index_spec_type not null,
    -- The documentdb_api.create_indexes() command that attempted
    -- to create the index got completed successfully ?
    --
    -- This either means that creation of this index is still in
    -- progress or documentdb_api.create_indexes() command failed but
    -- couldn't perform the clean-up for the indexes that it left
    -- behind.
    index_is_valid bool not null,
    PRIMARY KEY (index_id)
);
-- Speeds up queries based on index_name.
CREATE INDEX collection_index_name
ON documentdb_api_catalog.collection_indexes (collection_id, ((index_spec).index_name));
-- Speeds up queries based on index_key.
CREATE INDEX collection_index_key
ON documentdb_api_catalog.collection_indexes (collection_id, ((index_spec).index_key));
ALTER TYPE documentdb_api_catalog.index_spec_type_internal ADD ATTRIBUTE cosmos_search_options documentdb_core.bson;
ALTER TYPE documentdb_api_catalog.index_spec_type_internal ADD ATTRIBUTE index_options documentdb_core.bson;
CREATE OR REPLACE FUNCTION documentdb_api_internal.get_shard_key_value(
    p_shard_key documentdb_core.bson,
    p_collection_id bigint,
    p_document documentdb_core.bson)
 RETURNS bigint
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE
AS 'MODULE_PATHNAME', $$command_get_shard_key_value$$;
COMMENT ON FUNCTION documentdb_api_internal.get_shard_key_value(documentdb_core.bson,bigint,documentdb_core.bson)
    IS 'return the shard key value for the given document';
CREATE OR REPLACE FUNCTION documentdb_api.create_collection(p_database_name text, p_collection_name text)
RETURNS bool
LANGUAGE c
 STRICT
AS 'MODULE_PATHNAME', $function$command_create_collection_core$function$;
COMMENT ON FUNCTION documentdb_api.create_collection(p_database_name text, p_collection_name text)
    IS 'create a collection';
DROP FUNCTION IF EXISTS documentdb_api.shard_collection CASCADE;
CREATE OR REPLACE FUNCTION documentdb_api.shard_collection(
    p_database_name text,
    p_collection_name text,
    p_shard_key documentdb_core.bson,
    p_is_reshard bool default true)
 RETURNS void
 LANGUAGE C
   STRICT
 AS 'MODULE_PATHNAME', $$command_shard_collection$$;
 COMMENT ON FUNCTION documentdb_api.shard_collection(text, text,documentdb_core.bson,bool)
    IS 'Top level command to shard or reshard a collection';
-- create clones for the new schemas
CREATE OR REPLACE FUNCTION documentdb_api.shard_collection(
    p_shard_key_spec documentdb_core.bson)
 RETURNS void
 LANGUAGE C
   STRICT
 AS 'MODULE_PATHNAME', $$command_shard_collection$$;
CREATE OR REPLACE FUNCTION documentdb_api.reshard_collection(
    p_shard_key_spec documentdb_core.bson)
 RETURNS void
 LANGUAGE C
   STRICT
 AS 'MODULE_PATHNAME', $$command_reshard_collection$$;
CREATE OR REPLACE FUNCTION documentdb_api.unshard_collection(
    p_shard_key_spec documentdb_core.bson)
 RETURNS void
 LANGUAGE C
   STRICT
 AS 'MODULE_PATHNAME', $$command_unshard_collection$$;
-- collMod database command implementation for the Mongo wire protocol
CREATE OR REPLACE FUNCTION documentdb_api.coll_mod(
    IN p_database_name text,
    IN p_collection_name text,
    IN p_spec documentdb_core.bson)
RETURNS documentdb_core.bson
LANGUAGE C
VOLATILE PARALLEL UNSAFE
AS 'MODULE_PATHNAME', $function$command_coll_mod$function$;
COMMENT ON FUNCTION documentdb_api.coll_mod(text, text, documentdb_core.bson)
    IS 'Updates the specification of collection';
CREATE OR REPLACE FUNCTION documentdb_api.create_collection_view(dbname text, createSpec documentdb_core.bson)
 RETURNS documentdb_core.bson
 LANGUAGE c
 VOLATILE PARALLEL UNSAFE
AS 'MODULE_PATHNAME', $$command_create_collection_view$$;
DROP FUNCTION IF EXISTS documentdb_api.drop_collection CASCADE;
CREATE OR REPLACE FUNCTION documentdb_api.drop_collection(
    p_database_name text,
    p_collection_name text,
    p_write_concern documentdb_core.bson default null,
    p_collection_uuid uuid default null,
    p_track_changes bool default true)
RETURNS bool
LANGUAGE C
AS 'MODULE_PATHNAME', $function$command_drop_collection$function$;
COMMENT ON FUNCTION documentdb_api.drop_collection(text,text,documentdb_core.bson,uuid,bool)
    IS 'drop a collection';
CREATE OR REPLACE FUNCTION documentdb_api.drop_database(
    p_database_name text,
    p_write_concern documentdb_core.bson default null)
RETURNS void
SET search_path TO documentdb_core, pg_catalog
AS $fn$
DECLARE
    v_collection record;
BEGIN
    FOR
      v_collection
    IN
      SELECT
        database_name, collection_name
      FROM
        documentdb_api_catalog.collections
      WHERE
        database_name = p_database_name
    LOOP
        PERFORM documentdb_api.drop_collection(v_collection.database_name, v_collection.collection_name);
    END LOOP;
END;
$fn$ LANGUAGE plpgsql;
COMMENT ON FUNCTION documentdb_api.drop_database(text,documentdb_core.bson)
    IS 'drop a mongo database';
DROP FUNCTION IF EXISTS documentdb_api.rename_collection;
CREATE OR REPLACE FUNCTION documentdb_api.rename_collection(
    p_database_name text,
    p_collection_name text,
    p_target_name text,
    p_drop_target bool default false)
RETURNS void
LANGUAGE c
VOLATILE PARALLEL UNSAFE
AS 'MODULE_PATHNAME', $function$command_rename_collection$function$;
COMMENT ON FUNCTION documentdb_api.rename_collection(text, text, text, bool)
    IS 'rename a collection';
DROP FUNCTION IF EXISTS documentdb_api_internal.create_indexes_non_concurrently;
CREATE OR REPLACE FUNCTION documentdb_api_internal.create_indexes_non_concurrently(
    IN p_database_name text,
    IN p_arg documentdb_core.bson,
    IN p_skip_check_collection_create boolean default FALSE)
 RETURNS documentdb_core.bson
 LANGUAGE C
 VOLATILE
AS 'MODULE_PATHNAME', $$command_create_indexes_non_concurrently$$;
DROP FUNCTION IF EXISTS documentdb_api_internal.create_builtin_id_index;
CREATE OR REPLACE FUNCTION documentdb_api_internal.create_builtin_id_index(
    collection_id bigint, register_id_index bool default true
)
RETURNS void AS $fn$
DECLARE
    final_record record;
BEGIN
    EXECUTE format($$
        ALTER TABLE documentdb_data.documents_%s
        ADD CONSTRAINT collection_pk_%s
        PRIMARY KEY (shard_key_value, object_id)
    $$, collection_id, collection_id);
    IF register_id_index THEN
        PERFORM documentdb_api_internal.record_id_index(collection_id);
    END IF;
END;
$fn$
LANGUAGE plpgsql;
CREATE OR REPLACE FUNCTION documentdb_api_internal.record_id_index(
    p_collection_id bigint)
 RETURNS VOID
 LANGUAGE C
AS 'MODULE_PATHNAME', $$command_record_id_index$$;
COMMENT ON FUNCTION documentdb_api_internal.record_id_index(bigint)
    IS 'record built-in "_id" to index metadata';
CREATE OR REPLACE FUNCTION documentdb_api_internal.index_build_is_in_progress(
    p_index_id int)
 RETURNS boolean
 LANGUAGE C
AS 'MODULE_PATHNAME', $$command_index_build_is_in_progress$$;
DROP FUNCTION IF EXISTS documentdb_api_internal.index_spec_as_bson;
CREATE OR REPLACE FUNCTION documentdb_api_internal.index_spec_as_bson(
    index_spec documentdb_api_catalog.index_spec_type, for_get_indexes boolean default false, namespaceName text default NULL)
RETURNS documentdb_core.bson
LANGUAGE c
 IMMUTABLE PARALLEL SAFE
AS 'MODULE_PATHNAME', $function$index_spec_as_bson$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.index_spec_options_are_equivalent(
    left_index_spec documentdb_api_catalog.index_spec_type,
    right_index_spec documentdb_api_catalog.index_spec_type)
 RETURNS bool
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$index_spec_options_are_equivalent$function$;
CREATE OR REPLACE PROCEDURE documentdb_api_internal.build_index_concurrently(IN p_job_index int)
 LANGUAGE C
AS 'MODULE_PATHNAME', $procedure$command_build_index_concurrently$procedure$;
COMMENT ON PROCEDURE documentdb_api_internal.build_index_concurrently(int)
    IS 'Builds a index for a collection';
CREATE OR REPLACE FUNCTION documentdb_api_internal.check_build_index_status(
    IN p_arg documentdb_core.bson,
    OUT retval documentdb_core.bson,
    OUT ok boolean,
    OUT complete boolean)
 RETURNS record
 LANGUAGE C
 VOLATILE
AS 'MODULE_PATHNAME', $$command_check_build_index_status$$;
COMMENT ON FUNCTION documentdb_api_internal.check_build_index_status(documentdb_core.bson)
    IS 'Calls check_build_index_status_internal using run_command_on_coordinator.';
-- TODO: DROP the documentdb_api.create_indexes_background
CREATE OR REPLACE FUNCTION documentdb_api.create_indexes_background(
    p_database_name text,
    p_index_spec documentdb_core.bson,
    OUT retval documentdb_core.bson,
    OUT ok boolean,
    OUT requests documentdb_core.bson)
RETURNS record
 LANGUAGE C
 VOLATILE
AS 'MODULE_PATHNAME', $$command_create_indexes_background$$;
COMMENT ON FUNCTION documentdb_api.create_indexes_background(text, documentdb_core.bson)
    IS 'Submits the build index(es) requests on a collection and waits for them to finish.';
CREATE OR REPLACE FUNCTION documentdb_api_internal.check_build_index_status_internal(
    IN p_arg documentdb_core.bson)
 RETURNS documentdb_core.bson
 LANGUAGE C
 VOLATILE
AS 'MODULE_PATHNAME', $$command_check_build_index_status_internal$$;
COMMENT ON FUNCTION documentdb_api_internal.check_build_index_status_internal(documentdb_core.bson)
    IS 'Checks for build index(es) requests to finish.';
DROP FUNCTION IF EXISTS documentdb_api_internal.create_indexes_background_internal CASCADE;
CREATE OR REPLACE FUNCTION documentdb_api_internal.create_indexes_background_internal(
    IN p_database_name text,
    IN p_arg documentdb_core.bson)
 RETURNS documentdb_core.bson
 LANGUAGE C
 VOLATILE
AS 'MODULE_PATHNAME', $$command_create_indexes_background_internal$$;
COMMENT ON FUNCTION documentdb_api_internal.create_indexes_background_internal(text,documentdb_core.bson)
    IS 'Queues the Index creation request(s) on a collection';
CREATE OR REPLACE FUNCTION documentdb_api_internal.schedule_background_index_build_workers(p_max_num_active_user_index_builds int default current_setting('documentdb' || '.maxNumActiveUsersIndexBuilds')::int,
p_user_index_build_schedule int default current_setting('documentdb' || '.indexBuildScheduleInSec')::int)
RETURNS void
AS $fn$
DECLARE
    v_indexBuildScheduleInterval text;
BEGIN
    IF citus_is_coordinator() THEN
        SELECT '* * * * *' INTO v_indexBuildScheduleInterval;
        IF p_user_index_build_schedule < 60 THEN
            SELECT p_user_index_build_schedule || ' seconds' INTO v_indexBuildScheduleInterval;
        END IF;
        PERFORM cron.unschedule(jobid) FROM cron.job WHERE jobname LIKE 'documentdb' || '_index_build_task_%';
        FOR i IN 1..p_max_num_active_user_index_builds LOOP
            PERFORM cron.schedule('documentdb' || '_index_build_task_' || i, v_indexBuildScheduleInterval, format($$ CALL documentdb_api_internal.build_index_concurrently(%s) $$, i));
        END LOOP;
    ELSE
        RAISE EXCEPTION 'schedule_background_index_build_workers() to be run on coordinator only';
    END IF;
END;
$fn$ LANGUAGE plpgsql;
CREATE OR REPLACE PROCEDURE documentdb_api.drop_indexes(IN p_database_name text, IN p_arg documentdb_core.bson,
                                                      INOUT retval documentdb_core.bson DEFAULT null)
 LANGUAGE c
AS 'MODULE_PATHNAME', $procedure$command_drop_indexes$procedure$;
COMMENT ON PROCEDURE documentdb_api.drop_indexes(text, documentdb_core.bson, documentdb_core.bson)
    IS 'drop index(es) from a collection';
CREATE OR REPLACE FUNCTION documentdb_api.insert(
    p_database_name text,
    p_insert documentdb_core.bson,
    p_insert_documents documentdb_core.bsonsequence default NULL,
    p_transaction_id text default NULL,
    p_result OUT documentdb_core.bson,
    p_success OUT boolean)
 RETURNS record
 LANGUAGE C
AS 'MODULE_PATHNAME', $$command_insert$$;
COMMENT ON FUNCTION documentdb_api.insert(text,documentdb_core.bson,documentdb_core.bsonsequence,text)
    IS 'inserts documents into a collection for a mongo wire protocol command';
CREATE OR REPLACE FUNCTION documentdb_api_internal.insert_one(
    p_collection_id bigint,
    p_shard_key_value bigint,
    p_document documentdb_core.bson,
    p_transaction_id text)
 RETURNS bool
 LANGUAGE C
AS 'MODULE_PATHNAME', $$command_insert_one$$;
COMMENT ON FUNCTION documentdb_api_internal.insert_one(bigint,bigint,documentdb_core.bson,text)
    IS 'internal command to insert one document into a collection';
CREATE OR REPLACE FUNCTION documentdb_api_internal.insert_worker(
    p_collection_id bigint,
    p_shard_key_value bigint,
    p_shard_oid regclass,
    p_insert_internal_spec documentdb_core.bson,
    p_insert_internal_docs documentdb_core.bsonsequence,
    p_transaction_id text)
 RETURNS documentdb_core.bson
 LANGUAGE C
AS 'MODULE_PATHNAME', $$command_insert_worker$$;
CREATE OR REPLACE FUNCTION documentdb_api.insert_one(
    p_database_name text,
    p_collection_name text,
    p_document documentdb_core.bson,
    p_transaction_id text default null)
RETURNS documentdb_core.bson
SET search_path TO documentdb_core, pg_catalog
AS $fn$
DECLARE
    v_insert documentdb_core.bson;
    p_resultBson documentdb_core.bson;
BEGIN
 v_insert := ('{"insert":"' || p_collection_name || '" }')::bson;
    SELECT p_result INTO p_resultBson FROM documentdb_api.insert(
      p_database_name,
      v_insert,
      p_document::bsonsequence,
      p_transaction_id);
    RETURN p_resultBson;
END;
$fn$ LANGUAGE plpgsql;
COMMENT ON FUNCTION documentdb_api.insert_one(text,text,documentdb_core.bson,text)
    IS 'insert one document into a collection';
DROP FUNCTION IF EXISTS documentdb_api_internal.bson_update_document;
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_update_document(
    document documentdb_core.bson,
    updateSpec documentdb_core.bson,
    querySpec documentdb_core.bson,
    arrayFilters documentdb_core.bson DEFAULT NULL,
    buildUpdateDesc bool DEFAULT false,
    OUT newDocument documentdb_core.bson,
    OUT updateDesc documentdb_core.bson)
 RETURNS RECORD
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE
AS 'MODULE_PATHNAME', $function$bson_update_document$function$;
CREATE OR REPLACE FUNCTION documentdb_api.update(
    p_database_name text,
    p_update documentdb_core.bson,
    p_insert_documents documentdb_core.bsonsequence default NULL,
    p_transaction_id text default NULL,
    p_result OUT documentdb_core.bson,
    p_success OUT boolean)
 RETURNS record
 LANGUAGE C
 VOLATILE
AS 'MODULE_PATHNAME', $$command_update$$;
COMMENT ON FUNCTION documentdb_api.update(text,documentdb_core.bson,documentdb_core.bsonsequence,text)
    IS 'update documents in a collection';
CREATE OR REPLACE FUNCTION documentdb_api_internal.update_one(
    p_collection_id bigint,
    p_shard_key_value bigint,
    p_query documentdb_core.bson,
    p_update documentdb_core.bson,
    p_shard_key documentdb_core.bson,
    p_is_upsert bool,
    p_sort documentdb_core.bson,
    p_return_old_or_new bool,
    p_return_fields documentdb_core.bson,
    p_array_filters documentdb_core.bson,
    p_transaction_id text,
 OUT o_is_row_updated bool,
    OUT o_update_skipped bool,
 OUT o_is_retry bool,
 OUT o_reinsert_document documentdb_core.bson,
 OUT o_upserted_object_id bytea,
 OUT o_result_document documentdb_core.bson)
 RETURNS record
 LANGUAGE C
AS 'MODULE_PATHNAME', $$command_update_one$$;
COMMENT ON FUNCTION documentdb_api_internal.update_one(bigint,bigint,documentdb_core.bson,documentdb_core.bson,documentdb_core.bson,bool,documentdb_core.bson,bool,documentdb_core.bson,documentdb_core.bson,text)
    IS 'updates a single document in a collection';
CREATE OR REPLACE FUNCTION documentdb_api_internal.update_worker(
    p_collection_id bigint,
    p_shard_key_value bigint,
    p_shard_oid regclass,
    p_update_internal_spec documentdb_core.bson,
    p_update_internal_docs documentdb_core.bsonsequence,
    p_transaction_id text)
 RETURNS documentdb_core.bson
 LANGUAGE C
AS 'MODULE_PATHNAME', $$command_update_worker$$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_update_returned_value(shard_key_id bigint)
 RETURNS int
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$bson_update_returned_value$function$;
CREATE OR REPLACE FUNCTION documentdb_api.delete(
    p_database_name text,
    p_delete documentdb_core.bson,
    p_insert_documents documentdb_core.bsonsequence default NULL,
    p_transaction_id text default NULL,
    p_result OUT documentdb_core.bson,
    p_success OUT boolean)
 RETURNS record
 LANGUAGE C
AS 'MODULE_PATHNAME', $$command_delete$$;
COMMENT ON FUNCTION documentdb_api.delete(text,documentdb_core.bson,documentdb_core.bsonsequence,text)
    IS 'deletes documents from a collection';
CREATE OR REPLACE FUNCTION documentdb_api_internal.delete_one(
    p_collection_id bigint,
    p_shard_key_value bigint,
    p_query documentdb_core.bson,
    p_sort documentdb_core.bson,
    p_return_document bool,
    p_return_fields documentdb_core.bson,
    p_transaction_id text,
    OUT o_is_row_deleted bool,
    OUT o_result_deleted_document documentdb_core.bson)
 RETURNS record
 LANGUAGE C
AS 'MODULE_PATHNAME', $$command_delete_one$$;
COMMENT ON FUNCTION documentdb_api_internal.delete_one(bigint,bigint,documentdb_core.bson,documentdb_core.bson,bool,documentdb_core.bson,text)
    IS 'deletes a single document from a collection';
CREATE OR REPLACE FUNCTION documentdb_api_internal.delete_worker(
    p_collection_id bigint,
    p_shard_key_value bigint,
    p_shard_oid regclass,
    p_update_internal_spec documentdb_core.bson,
    p_update_internal_docs documentdb_core.bsonsequence,
    p_transaction_id text)
 RETURNS documentdb_core.bson
 LANGUAGE C
AS 'MODULE_PATHNAME', $$command_delete_worker$$;
CREATE OR REPLACE FUNCTION documentdb_api.find_and_modify(
    p_database_name text,
    p_message documentdb_core.bson,
    p_transaction_id text default NULL,
    p_result OUT documentdb_core.bson,
    p_success OUT boolean)
 RETURNS record
 LANGUAGE C
 VOLATILE
AS 'MODULE_PATHNAME', $$command_find_and_modify$$;
CREATE OR REPLACE FUNCTION documentdb_api.aggregate_cursor_first_page(
    database text, commandSpec documentdb_core.bson, cursorId int8 DEFAULT 0, OUT cursorPage documentdb_core.bson, OUT continuation documentdb_core.bson, OUT persistConnection bool, OUT cursorId int8)
RETURNS record
LANGUAGE C
VOLATILE PARALLEL UNSAFE STRICT
AS 'MODULE_PATHNAME', $function$command_aggregate_cursor_first_page$function$;
CREATE OR REPLACE FUNCTION documentdb_api.find_cursor_first_page(
    database text, commandSpec documentdb_core.bson, cursorId int8 DEFAULT 0, OUT cursorPage documentdb_core.bson, OUT continuation documentdb_core.bson, OUT persistConnection bool, OUT cursorId int8)
RETURNS record
LANGUAGE C
VOLATILE PARALLEL UNSAFE STRICT
AS 'MODULE_PATHNAME', $function$command_find_cursor_first_page$function$;
CREATE OR REPLACE FUNCTION documentdb_api.list_collections_cursor_first_page(
    database text, commandSpec documentdb_core.bson, cursorId int8 DEFAULT 0, OUT cursorPage documentdb_core.bson, OUT continuation documentdb_core.bson, OUT persistConnection bool, OUT cursorId int8)
RETURNS record
LANGUAGE C
VOLATILE PARALLEL UNSAFE STRICT
AS 'MODULE_PATHNAME', $function$command_list_collections_cursor_first_page$function$;
CREATE OR REPLACE FUNCTION documentdb_api.list_indexes_cursor_first_page(
    database text, commandSpec documentdb_core.bson, cursorId int8 DEFAULT 0, OUT cursorPage documentdb_core.bson, OUT continuation documentdb_core.bson, OUT persistConnection bool, OUT cursorId int8)
RETURNS record
LANGUAGE C
VOLATILE PARALLEL UNSAFE STRICT
AS 'MODULE_PATHNAME', $function$command_list_indexes_cursor_first_page$function$;
CREATE OR REPLACE FUNCTION documentdb_api.cursor_get_more(
    database text, getMoreSpec documentdb_core.bson, continuationSpec documentdb_core.bson, OUT cursorPage documentdb_core.bson, OUT continuation documentdb_core.bson)
RETURNS record
LANGUAGE C
VOLATILE PARALLEL UNSAFE STRICT
AS 'MODULE_PATHNAME', $function$command_cursor_get_more$function$;
CREATE OR REPLACE FUNCTION documentdb_api.count_query(database text, countSpec documentdb_core.bson, OUT document documentdb_core.bson)
RETURNS documentdb_core.bson
LANGUAGE C
VOLATILE PARALLEL UNSAFE STRICT
AS 'MODULE_PATHNAME', $function$command_count_query$function$;
CREATE OR REPLACE FUNCTION documentdb_api.distinct_query(database text, distinctSpec documentdb_core.bson, OUT document documentdb_core.bson)
RETURNS documentdb_core.bson
LANGUAGE C
VOLATILE PARALLEL UNSAFE STRICT
AS 'MODULE_PATHNAME', $function$command_distinct_query$function$;
DROP FUNCTION IF EXISTS documentdb_api.current_cursor_state(documentdb_core.bson);
DROP FUNCTION IF EXISTS documentdb_api.cursor_state(documentdb_core.bson, documentdb_core.bson);
-- This function is STABLE (Not Volatile) as within 1 transaction snapshot
-- The value given the "document" does not change.
-- However it's not guaranteed to be the same across transaction snapshots.
CREATE OR REPLACE FUNCTION documentdb_api_internal.current_cursor_state(documentdb_core.bson)
 RETURNS documentdb_core.bson
 LANGUAGE c
 STABLE
AS 'MODULE_PATHNAME', $function$command_current_cursor_state$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.cursor_state(documentdb_core.bson, documentdb_core.bson)
 RETURNS bool
 LANGUAGE c
 IMMUTABLE STRICT
AS 'MODULE_PATHNAME', $function$command_cursor_state$function$;
CREATE OR REPLACE FUNCTION documentdb_api.create_user(
    p_spec documentdb_core.bson)
 RETURNS documentdb_core.bson
 LANGUAGE C
 VOLATILE
AS 'MODULE_PATHNAME', $$documentdb_extension_create_user$$;
CREATE OR REPLACE FUNCTION documentdb_api.drop_user(
    p_spec documentdb_core.bson)
 RETURNS documentdb_core.bson
 LANGUAGE C
 VOLATILE
AS 'MODULE_PATHNAME', $$documentdb_extension_drop_user$$;
CREATE OR REPLACE FUNCTION documentdb_api.update_user(
    p_spec documentdb_core.bson)
 RETURNS documentdb_core.bson
 LANGUAGE C
 VOLATILE
AS 'MODULE_PATHNAME', $$documentdb_extension_update_user$$;
CREATE OR REPLACE FUNCTION documentdb_api.users_info(
    p_spec documentdb_core.bson)
 RETURNS documentdb_core.bson
 LANGUAGE C
 VOLATILE
AS 'MODULE_PATHNAME', $$documentdb_extension_get_users$$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.schema_validation_against_update(
    p_eval_state bytea,
    p_target_document documentdb_core.bson,
    p_source_document documentdb_core.bson,
    p_is_moderate boolean
   )
RETURNS boolean
LANGUAGE C
  STRICT
AS 'MODULE_PATHNAME', $$command_schema_validation_against_update$$;
-- This function is used to get current feature usage statistics for reporting to
-- the telemetry pipeline
CREATE OR REPLACE FUNCTION documentdb_api_internal.command_feature_counter_stats(
 IN reset_stats_after_read bool,
 OUT feature_name text,
 OUT usage_count int)
RETURNS SETOF RECORD
LANGUAGE C VOLATILE PARALLEL UNSAFE
AS 'MODULE_PATHNAME', $$get_feature_counter_stats$$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.delete_expired_rows_for_index(
    IN collection_id bigint,
    IN index_id bigint,
    IN index_key documentdb_core.bson,
    IN index_pfe documentdb_core.bson,
    IN current_datetime bigint,
    IN index_expiry int,
    IN ttl_batch_size int,
    IN shard_id bigint)
 RETURNS bigint
 LANGUAGE C
VOLATILE PARALLEL UNSAFE CALLED ON NULL INPUT
AS 'MODULE_PATHNAME', $function$delete_expired_rows_for_index$function$;
CREATE OR REPLACE PROCEDURE documentdb_api_internal.delete_expired_rows(IN p_batch_size int default -1)
AS $procedure$
DECLARE
    collection_row record;
    expired_rows_deleted bigint;
    start_time TIMESTAMP;
    end_time TIMESTAMP;
    config_value TEXT;
    elapsed_time INTERVAL;
    single_ttl_task_time_budget INTERVAL;
    exception_message TEXT;
    exception_detail TEXT;
BEGIN
    config_value := current_setting('documentdb' || '.SingleTTLTaskTimeBudget');
    single_ttl_task_time_budget := (config_value::INTEGER * '1 millisecond'::INTERVAL);
    start_time := clock_timestamp();
    SET LOCAL search_path TO documentdb_data;
    -- This loop goes over all the shards of a collection holding the ttl index and starts deleting data.
    FOR collection_row IN
        SELECT
            idx.collection_id,
            idx.index_id,
            (index_spec).index_key as key,
            (index_spec).index_pfe as pfe,
            trunc(extract(epoch FROM now()) * 1000, 0)::int8 as currentDateTime,
            (index_spec).index_expire_after_seconds as expiry,
            coll.shard_key,
            dist.shardid
        FROM documentdb_api_catalog.collection_indexes as idx, documentdb_api_catalog.collections as coll,
            pg_dist_shard as dist,
            pg_dist_placement as placement,
            pg_dist_local_group as lg
        WHERE index_is_valid AND (index_spec).index_expire_after_seconds >= 0
        AND idx.collection_id = coll.collection_id
        AND dist.logicalrelid = ('documents_' || coll.collection_id)::regclass
        AND placement.shardid = dist.shardid
        AND placement.groupid = lg.groupid -- filter shards that live on this worker node
        AND (dist.shardid = get_shard_id_for_distribution_column(logicalrelid, coll.collection_id) OR (coll.shard_key IS NOT NULL))
    LOOP
        expired_rows_deleted:= documentdb_api_internal.delete_expired_rows_for_index(
            collection_row.collection_id,
            collection_row.index_id,
            collection_row.key,
            collection_row.pfe,
            collection_row.currentDateTime,
            collection_row.expiry,
            p_batch_size,
            collection_row.shardid);
        end_time := clock_timestamp();
        elapsed_time := end_time - start_time;
        IF current_setting('documentdb' || '.logTTLProgressActivity')::BOOLEAN IS TRUE THEN
            RAISE LOG 'TTL task: deleted_documents=%, collection_id=%, index_id=%, shard_id=%, elapsed_time=%ms, budgeted_time=%ms',
            expired_rows_deleted,
            collection_row.collection_id,
            collection_row.index_id,
            collection_row.shardid,
            elapsed_time,
            single_ttl_task_time_budget;
        END IF;
        -- As long as we could delete data from any shards of a collection with ttl index
        -- we keep going until the time budget allocated for a single invocation of a
        -- ttl task exceeds.
        IF elapsed_time > single_ttl_task_time_budget THEN
            RETURN;
        END IF;
        COMMIT;
    END LOOP;
END;
$procedure$
LANGUAGE plpgsql;
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_extract_vector(document documentdb_core.bson, path text)
 RETURNS public.vector
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE RETURNS NULL ON NULL INPUT
AS 'MODULE_PATHNAME', $function$command_bson_extract_vector$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_search_param(documentdb_core.bson, documentdb_core.bson)
 RETURNS bool
 LANGUAGE c
 IMMUTABLE STRICT
AS 'MODULE_PATHNAME', $function$command_bson_search_param$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.bson_document_add_score_field(documentdb_core.bson, float8)
 RETURNS documentdb_core.bson
 LANGUAGE c
 IMMUTABLE STRICT
AS 'MODULE_PATHNAME', $function$command_bson_document_add_score_field$function$;
CREATE OR REPLACE FUNCTION documentdb_api.binary_version()
RETURNS text
LANGUAGE C
IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$get_documentdb_api_binary_version$function$;
CREATE OR REPLACE FUNCTION documentdb_api.binary_extended_version()
RETURNS text
LANGUAGE C
IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$get_documentdb_api_extended_binary_version$function$;
CREATE OR REPLACE FUNCTION documentdb_api.coll_stats(
    IN p_database_name text,
    IN p_collection_name text,
    IN p_scale float8 DEFAULT 1)
RETURNS documentdb_core.bson
LANGUAGE C
AS 'MODULE_PATHNAME', $function$command_coll_stats$function$;
COMMENT ON FUNCTION documentdb_api.coll_stats(text, text, float8)
    IS 'Returns variety of storage statistics for a given collection';
CREATE OR REPLACE FUNCTION documentdb_api_internal.coll_stats_worker(
    IN p_database_name text,
    IN p_collection_name text,
    IN p_scale float8 DEFAULT 1)
RETURNS documentdb_core.bson
LANGUAGE C
AS 'MODULE_PATHNAME', $function$command_coll_stats_worker$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.coll_stats_aggregation(
    IN p_database_name text,
    IN p_collection_name text,
    IN p_collStatsSpec documentdb_core.bson)
RETURNS documentdb_core.bson
LANGUAGE C STABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$command_coll_stats_aggregation$function$;
CREATE OR REPLACE FUNCTION documentdb_api.db_stats(
    IN p_database_name text,
    IN p_scale float8 DEFAULT 1,
    IN p_freeStorage bool DEFAULT false)
RETURNS documentdb_core.bson
LANGUAGE C
AS 'MODULE_PATHNAME', $function$command_db_stats$function$;
COMMENT ON FUNCTION documentdb_api.db_stats(text, float8, bool)
    IS 'Returns storage statistics for a given database';
CREATE OR REPLACE FUNCTION documentdb_api_internal.db_stats_worker(
    IN p_collection_ids bigint[])
RETURNS documentdb_core.bson
LANGUAGE C
AS 'MODULE_PATHNAME', $function$command_db_stats_worker$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.index_stats_aggregation(
    IN p_database_name text,
    IN p_collection_name text)
RETURNS SETOF documentdb_core.bson
LANGUAGE C STABLE PARALLEL SAFE STRICT ROWS 100
AS 'MODULE_PATHNAME', $function$command_index_stats_aggregation$function$;
CREATE OR REPLACE FUNCTION documentdb_api_internal.index_stats_worker(
    IN p_database_name text,
    IN p_collection_name text)
RETURNS documentdb_core.bson
LANGUAGE C STABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$command_index_stats_worker$function$;
CREATE OR REPLACE FUNCTION documentdb_api.validate(database text, validateSpec documentdb_core.bson, OUT document documentdb_core.bson)
RETURNS documentdb_core.bson
LANGUAGE C
VOLATILE PARALLEL UNSAFE STRICT
AS 'MODULE_PATHNAME', $function$command_validate$function$;
COMMENT ON FUNCTION documentdb_api.validate(text, documentdb_core.bson)
    IS 'Validates the indexes for a given collection';
DO
$do$
BEGIN
 IF NOT EXISTS (SELECT FROM pg_catalog.pg_roles WHERE rolname = 'documentdb_admin_role') THEN
        CREATE ROLE documentdb_admin_role;
    END IF;
END
$do$;
GRANT SELECT ON TABLE documentdb_api_catalog.collections TO public;
GRANT SELECT ON TABLE documentdb_api_catalog.collection_indexes TO public;
GRANT USAGE ON SCHEMA documentdb_api_catalog TO documentdb_admin_role;
GRANT USAGE ON SCHEMA documentdb_api_internal TO documentdb_admin_role;
GRANT USAGE ON SCHEMA documentdb_api TO documentdb_admin_role;
GRANT USAGE ON SCHEMA public TO documentdb_admin_role;
GRANT ALL ON SCHEMA documentdb_data TO documentdb_admin_role;
GRANT ALL ON TABLE documentdb_api_catalog.collections TO documentdb_admin_role;
GRANT ALL ON TABLE documentdb_api_catalog.collection_indexes TO documentdb_admin_role;
GRANT ALL ON SEQUENCE documentdb_api_catalog.collections_collection_id_seq TO documentdb_admin_role;
GRANT ALL ON SEQUENCE documentdb_api_catalog.collection_indexes_index_id_seq TO documentdb_admin_role;
GRANT USAGE ON SCHEMA documentdb_core TO documentdb_admin_role;
DO
$do$
BEGIN
 IF NOT EXISTS (SELECT FROM pg_catalog.pg_roles WHERE rolname = 'documentdb_readonly_role') THEN
        CREATE ROLE documentdb_readonly_role;
    END IF;
END
$do$;
GRANT USAGE ON SCHEMA documentdb_api_catalog TO documentdb_readonly_role;
GRANT USAGE ON SCHEMA documentdb_api_internal TO documentdb_readonly_role;
GRANT USAGE ON SCHEMA documentdb_api TO documentdb_readonly_role;
GRANT USAGE ON SCHEMA documentdb_data TO documentdb_readonly_role;
GRANT SELECT ON TABLE documentdb_api_catalog.collections TO documentdb_readonly_role;
GRANT SELECT ON TABLE documentdb_api_catalog.collection_indexes TO documentdb_readonly_role;
DROP TABLE IF EXISTS documentdb_api_catalog.documentdb_index_queue;
CREATE TABLE documentdb_api_catalog.documentdb_index_queue
(
    index_cmd text not null,
    cmd_type char CHECK (cmd_type IN ('C', 'R')), -- 'C' for CREATE INDEX and 'R' for REINDEX
    index_id integer not null,
    index_cmd_status integer default 1, -- This gets represented as enum IndexCmdStatus in index.h
    global_pid bigint,
    start_time timestamp WITH TIME ZONE,
    collection_id bigint not null,
    comment documentdb_core.bson,
    attempt smallint,
    update_time timestamp with time zone DEFAULT now()
);
CREATE INDEX IF NOT EXISTS documentdb_index_queue_indexid_cmdtype on documentdb_api_catalog.documentdb_index_queue (index_id, cmd_type);
CREATE INDEX IF NOT EXISTS documentdb_index_queue_cmdtype_collectionid_cmdstatus on documentdb_api_catalog.documentdb_index_queue (cmd_type, collection_id, index_cmd_status);
GRANT SELECT ON TABLE documentdb_api_catalog.documentdb_index_queue TO public;
GRANT ALL ON TABLE documentdb_api_catalog.documentdb_index_queue TO documentdb_admin_role;
DROP TABLE IF EXISTS documentdb_api_catalog.documentdb_index_queue;
CREATE TABLE documentdb_api_catalog.documentdb_index_queue
(
    index_cmd text not null,
    cmd_type char CHECK (cmd_type IN ('C', 'R')), -- 'C' for CREATE INDEX and 'R' for REINDEX
    index_id integer not null,
    index_cmd_status integer default 1, -- This gets represented as enum IndexCmdStatus in index.h
    global_pid bigint,
    start_time timestamp WITH TIME ZONE,
    collection_id bigint not null,
    comment documentdb_core.bson,
    attempt smallint,
    update_time timestamp with time zone DEFAULT now(),
    user_oid Oid CHECK (user_oid IS NULL OR user_oid != '0'::oid)
);
CREATE INDEX IF NOT EXISTS documentdb_index_queue_indexid_cmdtype on documentdb_api_catalog.documentdb_index_queue (index_id, cmd_type);
CREATE INDEX IF NOT EXISTS documentdb_index_queue_cmdtype_collectionid_cmdstatus on documentdb_api_catalog.documentdb_index_queue (cmd_type, collection_id, index_cmd_status);
GRANT SELECT ON TABLE documentdb_api_catalog.documentdb_index_queue TO public;
GRANT ALL ON TABLE documentdb_api_catalog.documentdb_index_queue TO documentdb_admin_role;
