
CREATE SCHEMA documentdb_core;
CREATE TYPE documentdb_core.bson;
CREATE OR REPLACE FUNCTION documentdb_core.bson_in(cstring)
 RETURNS documentdb_core.bson
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$bson_in$function$;
CREATE OR REPLACE FUNCTION documentdb_core.bson_out(documentdb_core.bson)
 RETURNS cstring
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$bson_out$function$;
CREATE OR REPLACE FUNCTION documentdb_core.bson_send(documentdb_core.bson)
 RETURNS bytea
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$bson_send$function$;
CREATE OR REPLACE FUNCTION documentdb_core.bson_recv(internal)
 RETURNS documentdb_core.bson
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$bson_recv$function$;
CREATE TYPE documentdb_core.bson (
    input = documentdb_core.bson_in,
    output = documentdb_core.bson_out,
    send = documentdb_core.bson_send,
    receive = documentdb_core.bson_recv,
    alignment = int4,
    storage = extended
);
CREATE OR REPLACE FUNCTION documentdb_core.bson_typanalyze(internal)
 RETURNS boolean
 LANGUAGE c
 STABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$bson_typanalyze$function$;
ALTER TYPE documentdb_core.bson SET ( ANALYZE = documentdb_core.bson_typanalyze );
CREATE TYPE documentdb_core.bsonsequence;
CREATE OR REPLACE FUNCTION documentdb_core.bsonsequence_in(cstring)
 RETURNS documentdb_core.bsonsequence
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$bsonsequence_in$function$;
CREATE OR REPLACE FUNCTION documentdb_core.bsonsequence_out(documentdb_core.bsonsequence)
 RETURNS cstring
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$bsonsequence_out$function$;
CREATE OR REPLACE FUNCTION documentdb_core.bsonsequence_send(documentdb_core.bsonsequence)
 RETURNS bytea
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$bsonsequence_send$function$;
CREATE OR REPLACE FUNCTION documentdb_core.bsonsequence_recv(internal)
 RETURNS documentdb_core.bsonsequence
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$bsonsequence_recv$function$;
CREATE TYPE documentdb_core.bsonsequence (
    input = documentdb_core.bsonsequence_in,
    output = documentdb_core.bsonsequence_out,
    send = documentdb_core.bsonsequence_send,
    receive = documentdb_core.bsonsequence_recv,
    alignment = int4,
    storage = extended
);
CREATE OR REPLACE FUNCTION documentdb_core.bson_get_value(documentdb_core.bson, text)
 RETURNS documentdb_core.bson
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$bson_get_value$function$;
CREATE OR REPLACE FUNCTION documentdb_core.bson_get_value_text(documentdb_core.bson, text)
 RETURNS text
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$bson_get_value_text$function$;
CREATE OR REPLACE FUNCTION documentdb_core.bson_from_bytea(bytea)
 RETURNS documentdb_core.bson
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$bson_from_bytea$function$;
CREATE OR REPLACE FUNCTION documentdb_core.bson_to_bytea(documentdb_core.bson)
 RETURNS bytea
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$bson_to_bytea$function$;
CREATE OR REPLACE FUNCTION documentdb_core.bson_to_bson_hex(documentdb_core.bson)
 RETURNS cstring
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$bson_to_bson_hex$function$;
CREATE OR REPLACE FUNCTION documentdb_core.bson_hex_to_bson(cstring)
 RETURNS documentdb_core.bson
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$bson_hex_to_bson$function$;
CREATE OR REPLACE FUNCTION documentdb_core.bson_json_to_bson(text)
 RETURNS documentdb_core.bson
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$bson_json_to_bson$function$;
CREATE OR REPLACE FUNCTION documentdb_core.bson_to_json_string(documentdb_core.bson)
 RETURNS cstring
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$bson_to_json_string$function$;
CREATE OR REPLACE FUNCTION documentdb_core.row_get_bson(record)
  RETURNS documentdb_core.bson
  LANGUAGE c
  IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$row_get_bson$function$;
CREATE OR REPLACE FUNCTION documentdb_core.bson_object_keys(documentdb_core.bson)
 RETURNS SETOF text
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT ROWS 100
AS 'MODULE_PATHNAME', $$bson_object_keys$$;
CREATE OR REPLACE FUNCTION documentdb_core.bson_repath_and_build(VARIADIC "any")
 RETURNS documentdb_core.bson
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$bson_repath_and_build$function$;
DROP CAST IF EXISTS (bytea AS documentdb_core.bson);
CREATE CAST (bytea AS documentdb_core.bson)
 WITH FUNCTION documentdb_core.bson_from_bytea(bytea) AS IMPLICIT;
DROP CAST IF EXISTS (documentdb_core.bson AS bytea);
CREATE CAST (documentdb_core.bson AS bytea)
 WITH FUNCTION documentdb_core.bson_to_bytea(documentdb_core.bson);
CREATE OR REPLACE FUNCTION documentdb_core.bsonsequence_from_bytea(bytea)
 RETURNS documentdb_core.bsonsequence
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$bsonsequence_from_bytea$function$;
CREATE OR REPLACE FUNCTION documentdb_core.bsonsequence_to_bytea(documentdb_core.bsonsequence)
 RETURNS bytea
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$bsonsequence_to_bytea$function$;
CREATE OR REPLACE FUNCTION documentdb_core.bson_to_bsonsequence(documentdb_core.bson)
 RETURNS documentdb_core.bsonsequence
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$bson_to_bsonsequence$function$;
CREATE OR REPLACE FUNCTION documentdb_core.bsonsequence_get_bson(documentdb_core.bsonsequence)
 RETURNS SETOF documentdb_core.bson
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT ROWS 100
AS 'MODULE_PATHNAME', $function$bsonsequence_get_bson$function$;
DROP CAST IF EXISTS (bytea AS documentdb_core.bsonsequence);
CREATE CAST (bytea AS documentdb_core.bsonsequence)
 WITH FUNCTION documentdb_core.bsonsequence_from_bytea(bytea) AS IMPLICIT;
DROP CAST IF EXISTS (documentdb_core.bsonsequence AS bytea);
CREATE CAST (documentdb_core.bsonsequence AS bytea)
 WITH FUNCTION documentdb_core.bsonsequence_to_bytea(documentdb_core.bsonsequence);
DROP CAST IF EXISTS (documentdb_core.bson AS documentdb_core.bsonsequence);
CREATE CAST (documentdb_core.bson AS documentdb_core.bsonsequence)
 WITH FUNCTION documentdb_core.bson_to_bsonsequence(documentdb_core.bson);
CREATE TYPE documentdb_core.bsonquery;
CREATE OR REPLACE FUNCTION documentdb_core.bsonquery_in(cstring)
 RETURNS documentdb_core.bsonquery
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$bson_in$function$;
CREATE OR REPLACE FUNCTION documentdb_core.bsonquery_out(documentdb_core.bsonquery)
 RETURNS cstring
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$bson_out$function$;
CREATE OR REPLACE FUNCTION documentdb_core.bsonquery_send(documentdb_core.bsonquery)
 RETURNS bytea
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$bson_send$function$;
CREATE OR REPLACE FUNCTION documentdb_core.bsonquery_recv(internal)
 RETURNS documentdb_core.bsonquery
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$bson_recv$function$;
CREATE TYPE documentdb_core.bsonquery (
    input = documentdb_core.bsonquery_in,
    output = documentdb_core.bsonquery_out,
    send = documentdb_core.bsonquery_send,
    receive = documentdb_core.bsonquery_recv,
    alignment = int4,
    storage = extended
);
CREATE OR REPLACE FUNCTION documentdb_core.bson_operator_selectivity(internal, oid, internal, integer)
 RETURNS double precision
 LANGUAGE c
 STABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$bson_operator_selectivity$function$;
DROP OPERATOR IF EXISTS documentdb_core.->(documentdb_core.bson, text);
CREATE OPERATOR documentdb_core.-> (
    LEFTARG = documentdb_core.bson,
    RIGHTARG = text,
    PROCEDURE = documentdb_core.bson_get_value
);
DROP OPERATOR IF EXISTS documentdb_core.->>(documentdb_core.bson, text);
CREATE OPERATOR documentdb_core.->> (
    LEFTARG = documentdb_core.bson,
    RIGHTARG = text,
    PROCEDURE = documentdb_core.bson_get_value_text
);
CREATE OR REPLACE FUNCTION documentdb_core.bson_compare(documentdb_core.bson, documentdb_core.bson)
 RETURNS int
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$extension_bson_compare$function$;
CREATE OR REPLACE FUNCTION documentdb_core.bson_equal(documentdb_core.bson, documentdb_core.bson)
 RETURNS bool
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$extension_bson_equal$function$;
CREATE OR REPLACE FUNCTION documentdb_core.bson_not_equal(documentdb_core.bson, documentdb_core.bson)
 RETURNS bool
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$extension_bson_not_equal$function$;
CREATE OR REPLACE FUNCTION documentdb_core.bson_lt(documentdb_core.bson, documentdb_core.bson)
 RETURNS bool
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$extension_bson_lt$function$;
CREATE OR REPLACE FUNCTION documentdb_core.bson_lte(documentdb_core.bson, documentdb_core.bson)
 RETURNS bool
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$extension_bson_lte$function$;
CREATE OR REPLACE FUNCTION documentdb_core.bson_gt(documentdb_core.bson, documentdb_core.bson)
 RETURNS bool
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$extension_bson_gt$function$;
CREATE OR REPLACE FUNCTION documentdb_core.bson_gte(documentdb_core.bson, documentdb_core.bson)
 RETURNS bool
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$extension_bson_gte$function$;
CREATE OR REPLACE FUNCTION documentdb_core.bson_unique_index_equal(documentdb_core.bson, documentdb_core.bson)
 RETURNS bool
 LANGUAGE C
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$bson_unique_index_equal$function$;
-- in_range support functions
CREATE OR REPLACE FUNCTION documentdb_core.bson_in_range_numeric(documentdb_core.bson, documentdb_core.bson, documentdb_core.bson, bool, bool)
 RETURNS bool
 LANGUAGE C
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$bson_in_range_numeric$function$;
CREATE OR REPLACE FUNCTION documentdb_core.bson_in_range_interval(documentdb_core.bson, documentdb_core.bson, interval, bool, bool)
 RETURNS bool
 LANGUAGE C
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$bson_in_range_interval$function$;
CREATE OPERATOR documentdb_core.= (
    LEFTARG = documentdb_core.bson,
    RIGHTARG = documentdb_core.bson,
    PROCEDURE = documentdb_core.bson_equal,
    RESTRICT = documentdb_core.bson_operator_selectivity,
    NEGATOR = OPERATOR(documentdb_core.<>)
);
CREATE OPERATOR documentdb_core.<> (
    LEFTARG = documentdb_core.bson,
    RIGHTARG = documentdb_core.bson,
    PROCEDURE = documentdb_core.bson_not_equal,
    RESTRICT = documentdb_core.bson_operator_selectivity,
    NEGATOR = OPERATOR(documentdb_core.=)
);
CREATE OPERATOR documentdb_core.< (
    LEFTARG = documentdb_core.bson,
    RIGHTARG = documentdb_core.bson,
    PROCEDURE = documentdb_core.bson_lt,
    RESTRICT = documentdb_core.bson_operator_selectivity,
    NEGATOR = OPERATOR(documentdb_core.>=)
);
CREATE OPERATOR documentdb_core.<= (
    LEFTARG = documentdb_core.bson,
    RIGHTARG = documentdb_core.bson,
    PROCEDURE = documentdb_core.bson_lte,
    RESTRICT = documentdb_core.bson_operator_selectivity,
    NEGATOR = OPERATOR(documentdb_core.>)
);
CREATE OPERATOR documentdb_core.> (
    LEFTARG = documentdb_core.bson,
    RIGHTARG = documentdb_core.bson,
    PROCEDURE = documentdb_core.bson_gt,
    RESTRICT = documentdb_core.bson_operator_selectivity,
    NEGATOR = OPERATOR(documentdb_core.<=)
);
CREATE OPERATOR documentdb_core.>= (
    LEFTARG = documentdb_core.bson,
    RIGHTARG = documentdb_core.bson,
    PROCEDURE = documentdb_core.bson_gte,
    RESTRICT = documentdb_core.bson_operator_selectivity,
    NEGATOR = OPERATOR(documentdb_core.<)
);
CREATE OR REPLACE FUNCTION documentdb_core.bsonquery_compare(documentdb_core.bsonquery, documentdb_core.bsonquery)
 RETURNS int
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$bsonquery_compare$function$;
CREATE OR REPLACE FUNCTION documentdb_core.bsonquery_compare(documentdb_core.bson, documentdb_core.bsonquery)
 RETURNS int
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$bsonquery_compare$function$;
CREATE OR REPLACE FUNCTION documentdb_core.bsonquery_equal(documentdb_core.bsonquery, documentdb_core.bsonquery)
 RETURNS bool
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$bsonquery_equal$function$;
CREATE OR REPLACE FUNCTION documentdb_core.bsonquery_not_equal(documentdb_core.bsonquery, documentdb_core.bsonquery)
 RETURNS bool
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$bsonquery_not_equal$function$;
CREATE OR REPLACE FUNCTION documentdb_core.bsonquery_lt(documentdb_core.bsonquery, documentdb_core.bsonquery)
 RETURNS bool
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$bsonquery_lt$function$;
CREATE OR REPLACE FUNCTION documentdb_core.bsonquery_lte(documentdb_core.bsonquery, documentdb_core.bsonquery)
 RETURNS bool
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$bsonquery_lte$function$;
CREATE OR REPLACE FUNCTION documentdb_core.bsonquery_gt(documentdb_core.bsonquery, documentdb_core.bsonquery)
 RETURNS bool
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$bsonquery_gt$function$;
CREATE OR REPLACE FUNCTION documentdb_core.bsonquery_gte(documentdb_core.bsonquery, documentdb_core.bsonquery)
 RETURNS bool
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$bsonquery_gte$function$;
CREATE OPERATOR documentdb_core.= (
    LEFTARG = documentdb_core.bsonquery,
    RIGHTARG = documentdb_core.bsonquery,
    PROCEDURE = documentdb_core.bsonquery_equal,
    RESTRICT = documentdb_core.bson_operator_selectivity,
    NEGATOR = OPERATOR(documentdb_core.<>)
);
CREATE OPERATOR documentdb_core.<> (
    LEFTARG = documentdb_core.bsonquery,
    RIGHTARG = documentdb_core.bsonquery,
    PROCEDURE = documentdb_core.bsonquery_not_equal,
    RESTRICT = documentdb_core.bson_operator_selectivity,
    NEGATOR = OPERATOR(documentdb_core.=)
);
CREATE OPERATOR documentdb_core.< (
    LEFTARG = documentdb_core.bsonquery,
    RIGHTARG = documentdb_core.bsonquery,
    PROCEDURE = documentdb_core.bsonquery_lt,
    RESTRICT = documentdb_core.bson_operator_selectivity,
    NEGATOR = OPERATOR(documentdb_core.>=)
);
CREATE OPERATOR documentdb_core.<= (
    LEFTARG = documentdb_core.bsonquery,
    RIGHTARG = documentdb_core.bsonquery,
    PROCEDURE = documentdb_core.bsonquery_lte,
    RESTRICT = documentdb_core.bson_operator_selectivity,
    NEGATOR = OPERATOR(documentdb_core.>)
);
CREATE OPERATOR documentdb_core.> (
    LEFTARG = documentdb_core.bsonquery,
    RIGHTARG = documentdb_core.bsonquery,
    PROCEDURE = documentdb_core.bsonquery_gt,
    RESTRICT = documentdb_core.bson_operator_selectivity,
    NEGATOR = OPERATOR(documentdb_core.<=)
);
CREATE OPERATOR documentdb_core.>= (
    LEFTARG = documentdb_core.bsonquery,
    RIGHTARG = documentdb_core.bsonquery,
    PROCEDURE = documentdb_core.bsonquery_gte,
    RESTRICT = documentdb_core.bson_operator_selectivity,
    NEGATOR = OPERATOR(documentdb_core.<)
);
CREATE OPERATOR CLASS documentdb_core.bson_btree_ops
    DEFAULT FOR TYPE documentdb_core.bson USING btree AS
        OPERATOR 1 documentdb_core.< (documentdb_core.bson, documentdb_core.bson),
        OPERATOR 2 documentdb_core.<= (documentdb_core.bson, documentdb_core.bson),
        OPERATOR 3 documentdb_core.= (documentdb_core.bson, documentdb_core.bson),
        OPERATOR 4 documentdb_core.>= (documentdb_core.bson, documentdb_core.bson),
        OPERATOR 5 documentdb_core.> (documentdb_core.bson, documentdb_core.bson),
        FUNCTION 1 documentdb_core.bson_compare(documentdb_core.bson, documentdb_core.bson);
ALTER OPERATOR FAMILY documentdb_core.bson_btree_ops USING btree ADD FUNCTION 3 documentdb_core.bson_in_range_numeric(documentdb_core.bson, documentdb_core.bson, documentdb_core.bson, bool, bool); -- To check RANGE with numeric values for Partition by
ALTER OPERATOR FAMILY documentdb_core.bson_btree_ops USING btree ADD FUNCTION 3 documentdb_core.bson_in_range_interval(documentdb_core.bson, documentdb_core.bson, interval, bool, bool); -- To check RANGE with interval value for Partition by
CREATE OR REPLACE FUNCTION documentdb_core.bson_hash_int4(documentdb_core.bson)
 RETURNS int4
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$extension_bson_hash_int4$function$;
CREATE OR REPLACE FUNCTION documentdb_core.bson_hash_int8(documentdb_core.bson, int8)
 RETURNS int8
 LANGUAGE c
 IMMUTABLE PARALLEL SAFE STRICT
AS 'MODULE_PATHNAME', $function$extension_bson_hash_int8$function$;
-- Creating a hash operator class for index type hash is used by the postgres planner
-- if there's a GROUP BY, DISTINCT, or grouping operations in general. If a hashable
-- type is available, then a HashAgg is created instead of sorting/grouping which
-- could be more efficient and consume less memory and take less time.
CREATE OPERATOR CLASS documentdb_core.bson_hash_ops
    DEFAULT FOR TYPE documentdb_core.bson USING hash AS
        OPERATOR 1 documentdb_core.= (documentdb_core.bson, documentdb_core.bson),
        FUNCTION 1 documentdb_core.bson_hash_int4(documentdb_core.bson),
        FUNCTION 2 documentdb_core.bson_hash_int8(documentdb_core.bson, int8);
